/* Bezier.c generated by valac 0.56.17, the Vala compiler
 * generated from Bezier.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_BEZIER (bezier_get_type ())
#define BEZIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BEZIER, Bezier))
#define BEZIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BEZIER, BezierClass))
#define IS_BEZIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BEZIER))
#define IS_BEZIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BEZIER))
#define BEZIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BEZIER, BezierClass))

typedef struct _Bezier Bezier;
typedef struct _BezierClass BezierClass;
typedef struct _BezierPrivate BezierPrivate;

#define BEZIER_TYPE_POINT (bezier_point_get_type ())
#define BEZIER_POINT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BEZIER_TYPE_POINT, BezierPoint))
#define BEZIER_POINT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BEZIER_TYPE_POINT, BezierPointClass))
#define BEZIER_IS_POINT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BEZIER_TYPE_POINT))
#define BEZIER_IS_POINT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BEZIER_TYPE_POINT))
#define BEZIER_POINT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BEZIER_TYPE_POINT, BezierPointClass))

typedef struct _BezierPoint BezierPoint;
typedef struct _BezierPointClass BezierPointClass;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _bezier_point_unref0(var) ((var == NULL) ? NULL : (var = (bezier_point_unref (var), NULL)))

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef struct _BezierPointPrivate BezierPointPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _BezierParamSpecPoint BezierParamSpecPoint;
typedef struct _ParamSpecBezier ParamSpecBezier;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Bezier {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BezierPrivate * priv;
};

struct _BezierClass {
	GTypeClass parent_class;
	void (*finalize) (Bezier *self);
};

struct _BezierPrivate {
	GArray* _points;
	GArray* _apoints;
	BezierPoint* _from;
	BezierPoint* _to;
};

struct _BezierPoint {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BezierPointPrivate * priv;
};

struct _BezierPointClass {
	GTypeClass parent_class;
	void (*finalize) (BezierPoint *self);
};

struct _BezierPointPrivate {
	DrawArea* _da;
	gdouble _x;
	gdouble _y;
};

struct _BezierParamSpecPoint {
	GParamSpec parent_instance;
};

struct _ParamSpecBezier {
	GParamSpec parent_instance;
};

static gint Bezier_private_offset;
static gpointer bezier_parent_class = NULL;
static gint BezierPoint_private_offset;
static gpointer bezier_point_parent_class = NULL;

VALA_EXTERN gpointer bezier_ref (gpointer instance);
VALA_EXTERN void bezier_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_bezier (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
VALA_EXTERN void value_set_bezier (GValue* value,
                       gpointer v_object);
VALA_EXTERN void value_take_bezier (GValue* value,
                        gpointer v_object);
VALA_EXTERN gpointer value_get_bezier (const GValue* value);
VALA_EXTERN GType bezier_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bezier, bezier_unref)
static gpointer bezier_point_ref (gpointer instance);
static void bezier_point_unref (gpointer instance);
static GParamSpec* bezier_param_spec_point (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags) G_GNUC_UNUSED ;
static void bezier_value_set_point (GValue* value,
                             gpointer v_object) G_GNUC_UNUSED ;
static void bezier_value_take_point (GValue* value,
                              gpointer v_object) G_GNUC_UNUSED ;
static gpointer bezier_value_get_point (const GValue* value) G_GNUC_UNUSED ;
static GType bezier_point_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BezierPoint, bezier_point_unref)
static void _bezier_point_unref0_ (gpointer var);
static void _vala_BezierPoint_free_function_content_of (gpointer data);
VALA_EXTERN GType draw_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
VALA_EXTERN Bezier* bezier_new (DrawArea* da);
VALA_EXTERN Bezier* bezier_construct (GType object_type,
                          DrawArea* da);
static BezierPoint* bezier_point_new (DrawArea* da);
static BezierPoint* bezier_point_construct (GType object_type,
                                     DrawArea* da);
VALA_EXTERN Bezier* bezier_new_with_endpoints (DrawArea* da,
                                   gdouble x0,
                                   gdouble y0,
                                   gdouble x1,
                                   gdouble y1);
VALA_EXTERN Bezier* bezier_construct_with_endpoints (GType object_type,
                                         DrawArea* da,
                                         gdouble x0,
                                         gdouble y0,
                                         gdouble x1,
                                         gdouble y1);
static void bezier_point_set_coordinate (BezierPoint* self,
                                  gdouble a,
                                  gdouble b);
VALA_EXTERN void bezier_copy (Bezier* self,
                  Bezier* b);
static gdouble bezier_point_get_x (BezierPoint* self);
static gdouble bezier_point_get_y (BezierPoint* self);
VALA_EXTERN void bezier_get_point (Bezier* self,
                       gint pindex,
                       gdouble* x,
                       gdouble* y);
VALA_EXTERN void bezier_get_from_point (Bezier* self,
                            gdouble* x,
                            gdouble* y);
VALA_EXTERN void bezier_get_to_point (Bezier* self,
                          gdouble* x,
                          gdouble* y);
VALA_EXTERN void bezier_get_drag_point (Bezier* self,
                            gdouble* x,
                            gdouble* y);
VALA_EXTERN void bezier_set_point (Bezier* self,
                       gint pindex,
                       gdouble x,
                       gdouble y);
VALA_EXTERN void bezier_update_control_from_drag_handle (Bezier* self,
                                             gdouble x,
                                             gdouble y);
static gboolean bezier_is_t_within_range (Bezier* self,
                                   gdouble t);
static void bezier_align_point (Bezier* self,
                         gint pindex,
                         gdouble a,
                         gdouble tx,
                         gdouble ty);
static void bezier_align (Bezier* self,
                   gdouble lx0,
                   gdouble ly0,
                   gdouble lx1,
                   gdouble ly1);
static void bezier_get_roots (Bezier* self,
                       gdouble axis,
                       gboolean axis_is_x,
                       GArray** roots);
static gdouble* _double_dup (gdouble* self);
static gdouble bezier_get_axis (Bezier* self,
                         gdouble t,
                         gboolean axis_is_x);
VALA_EXTERN gboolean bezier_within_range (Bezier* self,
                              gdouble x,
                              gdouble y);
static void _g_free0_ (gpointer var);
static void _vala_gdouble_free_function_content_of (gpointer data);
VALA_EXTERN gdouble* bezier_get_intersecting_point (Bezier* self,
                                        gdouble axis,
                                        gboolean axis_is_x,
                                        gboolean from);
VALA_EXTERN void bezier_set_connect_point (Bezier* self,
                               gboolean from,
                               gdouble top,
                               gdouble bottom,
                               gdouble left,
                               gdouble right);
static BezierPoint* bezier_point_new_with_coordinate (DrawArea* da,
                                               gdouble a,
                                               gdouble b);
static BezierPoint* bezier_point_construct_with_coordinate (GType object_type,
                                                     DrawArea* da,
                                                     gdouble a,
                                                     gdouble b);
static void bezier_point_set_x (BezierPoint* self,
                         gdouble value);
static void bezier_point_set_y (BezierPoint* self,
                         gdouble value);
VALA_EXTERN gdouble draw_area_get_origin_x (DrawArea* self);
VALA_EXTERN gdouble draw_area_get_origin_y (DrawArea* self);
static void bezier_point_finalize (BezierPoint * obj);
static GType bezier_point_get_type_once (void);
static void bezier_finalize (Bezier * obj);
static GType bezier_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
bezier_get_instance_private (Bezier* self)
{
	return G_STRUCT_MEMBER_P (self, Bezier_private_offset);
}

static void
_bezier_point_unref0_ (gpointer var)
{
#line 60 "../src/Bezier.vala"
	(var == NULL) ? NULL : (var = (bezier_point_unref (var), NULL));
#line 288 "Bezier.c"
}

static void
_vala_BezierPoint_free_function_content_of (gpointer data)
{
	BezierPoint* self;
#line 60 "../src/Bezier.vala"
	self = *((BezierPoint**) data);
#line 60 "../src/Bezier.vala"
	_bezier_point_unref0_ (self);
#line 299 "Bezier.c"
}

Bezier*
bezier_construct (GType object_type,
                  DrawArea* da)
{
	Bezier* self = NULL;
	BezierPoint* _tmp0_;
	BezierPoint* _tmp1_;
#line 66 "../src/Bezier.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 66 "../src/Bezier.vala"
	self = (Bezier*) g_type_create_instance (object_type);
#line 67 "../src/Bezier.vala"
	_tmp0_ = bezier_point_new (da);
#line 67 "../src/Bezier.vala"
	_bezier_point_unref0 (self->priv->_from);
#line 67 "../src/Bezier.vala"
	self->priv->_from = _tmp0_;
#line 68 "../src/Bezier.vala"
	_tmp1_ = bezier_point_new (da);
#line 68 "../src/Bezier.vala"
	_bezier_point_unref0 (self->priv->_to);
#line 68 "../src/Bezier.vala"
	self->priv->_to = _tmp1_;
#line 325 "Bezier.c"
	{
		gint i = 0;
#line 69 "../src/Bezier.vala"
		i = 0;
#line 330 "Bezier.c"
		{
			gboolean _tmp2_ = FALSE;
#line 69 "../src/Bezier.vala"
			_tmp2_ = TRUE;
#line 69 "../src/Bezier.vala"
			while (TRUE) {
#line 337 "Bezier.c"
				GArray* _tmp4_;
				BezierPoint* _tmp5_;
				GArray* _tmp6_;
				BezierPoint* _tmp7_;
#line 69 "../src/Bezier.vala"
				if (!_tmp2_) {
#line 344 "Bezier.c"
					gint _tmp3_;
#line 69 "../src/Bezier.vala"
					_tmp3_ = i;
#line 69 "../src/Bezier.vala"
					i = _tmp3_ + 1;
#line 350 "Bezier.c"
				}
#line 69 "../src/Bezier.vala"
				_tmp2_ = FALSE;
#line 69 "../src/Bezier.vala"
				if (!(i < 3)) {
#line 69 "../src/Bezier.vala"
					break;
#line 358 "Bezier.c"
				}
#line 70 "../src/Bezier.vala"
				_tmp4_ = self->priv->_points;
#line 70 "../src/Bezier.vala"
				_tmp5_ = bezier_point_new (da);
#line 70 "../src/Bezier.vala"
				g_array_append_val (_tmp4_, _tmp5_);
#line 71 "../src/Bezier.vala"
				_tmp6_ = self->priv->_apoints;
#line 71 "../src/Bezier.vala"
				_tmp7_ = bezier_point_new (da);
#line 71 "../src/Bezier.vala"
				g_array_append_val (_tmp6_, _tmp7_);
#line 372 "Bezier.c"
			}
		}
	}
#line 66 "../src/Bezier.vala"
	return self;
#line 378 "Bezier.c"
}

Bezier*
bezier_new (DrawArea* da)
{
#line 66 "../src/Bezier.vala"
	return bezier_construct (TYPE_BEZIER, da);
#line 386 "Bezier.c"
}

Bezier*
bezier_construct_with_endpoints (GType object_type,
                                 DrawArea* da,
                                 gdouble x0,
                                 gdouble y0,
                                 gdouble x1,
                                 gdouble y1)
{
	Bezier* self = NULL;
	BezierPoint* _tmp0_;
	BezierPoint* _tmp1_;
	GArray* _tmp8_;
	BezierPoint* _tmp9_;
	GArray* _tmp10_;
	BezierPoint* _tmp11_;
	GArray* _tmp12_;
	BezierPoint* _tmp13_;
#line 76 "../src/Bezier.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 76 "../src/Bezier.vala"
	self = (Bezier*) g_type_create_instance (object_type);
#line 77 "../src/Bezier.vala"
	_tmp0_ = bezier_point_new (da);
#line 77 "../src/Bezier.vala"
	_bezier_point_unref0 (self->priv->_from);
#line 77 "../src/Bezier.vala"
	self->priv->_from = _tmp0_;
#line 78 "../src/Bezier.vala"
	_tmp1_ = bezier_point_new (da);
#line 78 "../src/Bezier.vala"
	_bezier_point_unref0 (self->priv->_to);
#line 78 "../src/Bezier.vala"
	self->priv->_to = _tmp1_;
#line 422 "Bezier.c"
	{
		gint i = 0;
#line 79 "../src/Bezier.vala"
		i = 0;
#line 427 "Bezier.c"
		{
			gboolean _tmp2_ = FALSE;
#line 79 "../src/Bezier.vala"
			_tmp2_ = TRUE;
#line 79 "../src/Bezier.vala"
			while (TRUE) {
#line 434 "Bezier.c"
				GArray* _tmp4_;
				BezierPoint* _tmp5_;
				GArray* _tmp6_;
				BezierPoint* _tmp7_;
#line 79 "../src/Bezier.vala"
				if (!_tmp2_) {
#line 441 "Bezier.c"
					gint _tmp3_;
#line 79 "../src/Bezier.vala"
					_tmp3_ = i;
#line 79 "../src/Bezier.vala"
					i = _tmp3_ + 1;
#line 447 "Bezier.c"
				}
#line 79 "../src/Bezier.vala"
				_tmp2_ = FALSE;
#line 79 "../src/Bezier.vala"
				if (!(i < 3)) {
#line 79 "../src/Bezier.vala"
					break;
#line 455 "Bezier.c"
				}
#line 80 "../src/Bezier.vala"
				_tmp4_ = self->priv->_points;
#line 80 "../src/Bezier.vala"
				_tmp5_ = bezier_point_new (da);
#line 80 "../src/Bezier.vala"
				g_array_append_val (_tmp4_, _tmp5_);
#line 81 "../src/Bezier.vala"
				_tmp6_ = self->priv->_apoints;
#line 81 "../src/Bezier.vala"
				_tmp7_ = bezier_point_new (da);
#line 81 "../src/Bezier.vala"
				g_array_append_val (_tmp6_, _tmp7_);
#line 469 "Bezier.c"
			}
		}
	}
#line 83 "../src/Bezier.vala"
	_tmp8_ = self->priv->_points;
#line 83 "../src/Bezier.vala"
	_tmp9_ = g_array_index (_tmp8_, BezierPoint*, (guint) 0);
#line 83 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp9_, x0, y0);
#line 84 "../src/Bezier.vala"
	_tmp10_ = self->priv->_points;
#line 84 "../src/Bezier.vala"
	_tmp11_ = g_array_index (_tmp10_, BezierPoint*, (guint) 1);
#line 84 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp11_, (x0 + x1) * 0.5, (y0 + y1) * 0.5);
#line 85 "../src/Bezier.vala"
	_tmp12_ = self->priv->_points;
#line 85 "../src/Bezier.vala"
	_tmp13_ = g_array_index (_tmp12_, BezierPoint*, (guint) 2);
#line 85 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp13_, x1, y1);
#line 76 "../src/Bezier.vala"
	return self;
#line 493 "Bezier.c"
}

Bezier*
bezier_new_with_endpoints (DrawArea* da,
                           gdouble x0,
                           gdouble y0,
                           gdouble x1,
                           gdouble y1)
{
#line 76 "../src/Bezier.vala"
	return bezier_construct_with_endpoints (TYPE_BEZIER, da, x0, y0, x1, y1);
#line 505 "Bezier.c"
}

void
bezier_copy (Bezier* self,
             Bezier* b)
{
	BezierPoint* _tmp22_;
	BezierPoint* _tmp23_;
	gdouble _tmp24_;
	gdouble _tmp25_;
	BezierPoint* _tmp26_;
	gdouble _tmp27_;
	gdouble _tmp28_;
	BezierPoint* _tmp29_;
	BezierPoint* _tmp30_;
	gdouble _tmp31_;
	gdouble _tmp32_;
	BezierPoint* _tmp33_;
	gdouble _tmp34_;
	gdouble _tmp35_;
#line 89 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/Bezier.vala"
	g_return_if_fail (b != NULL);
#line 530 "Bezier.c"
	{
		gint i = 0;
#line 90 "../src/Bezier.vala"
		i = 0;
#line 535 "Bezier.c"
		{
			gboolean _tmp0_ = FALSE;
#line 90 "../src/Bezier.vala"
			_tmp0_ = TRUE;
#line 90 "../src/Bezier.vala"
			while (TRUE) {
#line 542 "Bezier.c"
				GArray* _tmp2_;
				BezierPoint* _tmp3_;
				GArray* _tmp4_;
				BezierPoint* _tmp5_;
				gdouble _tmp6_;
				gdouble _tmp7_;
				GArray* _tmp8_;
				BezierPoint* _tmp9_;
				gdouble _tmp10_;
				gdouble _tmp11_;
				GArray* _tmp12_;
				BezierPoint* _tmp13_;
				GArray* _tmp14_;
				BezierPoint* _tmp15_;
				gdouble _tmp16_;
				gdouble _tmp17_;
				GArray* _tmp18_;
				BezierPoint* _tmp19_;
				gdouble _tmp20_;
				gdouble _tmp21_;
#line 90 "../src/Bezier.vala"
				if (!_tmp0_) {
#line 565 "Bezier.c"
					gint _tmp1_;
#line 90 "../src/Bezier.vala"
					_tmp1_ = i;
#line 90 "../src/Bezier.vala"
					i = _tmp1_ + 1;
#line 571 "Bezier.c"
				}
#line 90 "../src/Bezier.vala"
				_tmp0_ = FALSE;
#line 90 "../src/Bezier.vala"
				if (!(i < 3)) {
#line 90 "../src/Bezier.vala"
					break;
#line 579 "Bezier.c"
				}
#line 91 "../src/Bezier.vala"
				_tmp2_ = self->priv->_points;
#line 91 "../src/Bezier.vala"
				_tmp3_ = g_array_index (_tmp2_, BezierPoint*, (guint) i);
#line 91 "../src/Bezier.vala"
				_tmp4_ = b->priv->_points;
#line 91 "../src/Bezier.vala"
				_tmp5_ = g_array_index (_tmp4_, BezierPoint*, (guint) i);
#line 91 "../src/Bezier.vala"
				_tmp6_ = bezier_point_get_x (_tmp5_);
#line 91 "../src/Bezier.vala"
				_tmp7_ = _tmp6_;
#line 91 "../src/Bezier.vala"
				_tmp8_ = b->priv->_points;
#line 91 "../src/Bezier.vala"
				_tmp9_ = g_array_index (_tmp8_, BezierPoint*, (guint) i);
#line 91 "../src/Bezier.vala"
				_tmp10_ = bezier_point_get_y (_tmp9_);
#line 91 "../src/Bezier.vala"
				_tmp11_ = _tmp10_;
#line 91 "../src/Bezier.vala"
				bezier_point_set_coordinate (_tmp3_, _tmp7_, _tmp11_);
#line 92 "../src/Bezier.vala"
				_tmp12_ = self->priv->_apoints;
#line 92 "../src/Bezier.vala"
				_tmp13_ = g_array_index (_tmp12_, BezierPoint*, (guint) i);
#line 92 "../src/Bezier.vala"
				_tmp14_ = b->priv->_apoints;
#line 92 "../src/Bezier.vala"
				_tmp15_ = g_array_index (_tmp14_, BezierPoint*, (guint) i);
#line 92 "../src/Bezier.vala"
				_tmp16_ = bezier_point_get_x (_tmp15_);
#line 92 "../src/Bezier.vala"
				_tmp17_ = _tmp16_;
#line 92 "../src/Bezier.vala"
				_tmp18_ = b->priv->_apoints;
#line 92 "../src/Bezier.vala"
				_tmp19_ = g_array_index (_tmp18_, BezierPoint*, (guint) i);
#line 92 "../src/Bezier.vala"
				_tmp20_ = bezier_point_get_y (_tmp19_);
#line 92 "../src/Bezier.vala"
				_tmp21_ = _tmp20_;
#line 92 "../src/Bezier.vala"
				bezier_point_set_coordinate (_tmp13_, _tmp17_, _tmp21_);
#line 625 "Bezier.c"
			}
		}
	}
#line 94 "../src/Bezier.vala"
	_tmp22_ = self->priv->_from;
#line 94 "../src/Bezier.vala"
	_tmp23_ = b->priv->_from;
#line 94 "../src/Bezier.vala"
	_tmp24_ = bezier_point_get_x (_tmp23_);
#line 94 "../src/Bezier.vala"
	_tmp25_ = _tmp24_;
#line 94 "../src/Bezier.vala"
	_tmp26_ = b->priv->_from;
#line 94 "../src/Bezier.vala"
	_tmp27_ = bezier_point_get_y (_tmp26_);
#line 94 "../src/Bezier.vala"
	_tmp28_ = _tmp27_;
#line 94 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp22_, _tmp25_, _tmp28_);
#line 95 "../src/Bezier.vala"
	_tmp29_ = self->priv->_to;
#line 95 "../src/Bezier.vala"
	_tmp30_ = b->priv->_to;
#line 95 "../src/Bezier.vala"
	_tmp31_ = bezier_point_get_x (_tmp30_);
#line 95 "../src/Bezier.vala"
	_tmp32_ = _tmp31_;
#line 95 "../src/Bezier.vala"
	_tmp33_ = b->priv->_to;
#line 95 "../src/Bezier.vala"
	_tmp34_ = bezier_point_get_y (_tmp33_);
#line 95 "../src/Bezier.vala"
	_tmp35_ = _tmp34_;
#line 95 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp29_, _tmp32_, _tmp35_);
#line 661 "Bezier.c"
}

void
bezier_get_point (Bezier* self,
                  gint pindex,
                  gdouble* x,
                  gdouble* y)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	GArray* _tmp0_;
	BezierPoint* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GArray* _tmp4_;
	BezierPoint* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
#line 99 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/Bezier.vala"
	_tmp0_ = self->priv->_points;
#line 100 "../src/Bezier.vala"
	_tmp1_ = g_array_index (_tmp0_, BezierPoint*, (guint) pindex);
#line 100 "../src/Bezier.vala"
	_tmp2_ = bezier_point_get_x (_tmp1_);
#line 100 "../src/Bezier.vala"
	_tmp3_ = _tmp2_;
#line 100 "../src/Bezier.vala"
	_vala_x = _tmp3_;
#line 101 "../src/Bezier.vala"
	_tmp4_ = self->priv->_points;
#line 101 "../src/Bezier.vala"
	_tmp5_ = g_array_index (_tmp4_, BezierPoint*, (guint) pindex);
#line 101 "../src/Bezier.vala"
	_tmp6_ = bezier_point_get_y (_tmp5_);
#line 101 "../src/Bezier.vala"
	_tmp7_ = _tmp6_;
#line 101 "../src/Bezier.vala"
	_vala_y = _tmp7_;
#line 99 "../src/Bezier.vala"
	if (x) {
#line 99 "../src/Bezier.vala"
		*x = _vala_x;
#line 706 "Bezier.c"
	}
#line 99 "../src/Bezier.vala"
	if (y) {
#line 99 "../src/Bezier.vala"
		*y = _vala_y;
#line 712 "Bezier.c"
	}
}

void
bezier_get_from_point (Bezier* self,
                       gdouble* x,
                       gdouble* y)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	BezierPoint* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	BezierPoint* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
#line 104 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/Bezier.vala"
	_tmp0_ = self->priv->_from;
#line 105 "../src/Bezier.vala"
	_tmp1_ = bezier_point_get_x (_tmp0_);
#line 105 "../src/Bezier.vala"
	_tmp2_ = _tmp1_;
#line 105 "../src/Bezier.vala"
	_vala_x = _tmp2_;
#line 106 "../src/Bezier.vala"
	_tmp3_ = self->priv->_from;
#line 106 "../src/Bezier.vala"
	_tmp4_ = bezier_point_get_y (_tmp3_);
#line 106 "../src/Bezier.vala"
	_tmp5_ = _tmp4_;
#line 106 "../src/Bezier.vala"
	_vala_y = _tmp5_;
#line 104 "../src/Bezier.vala"
	if (x) {
#line 104 "../src/Bezier.vala"
		*x = _vala_x;
#line 751 "Bezier.c"
	}
#line 104 "../src/Bezier.vala"
	if (y) {
#line 104 "../src/Bezier.vala"
		*y = _vala_y;
#line 757 "Bezier.c"
	}
}

void
bezier_get_to_point (Bezier* self,
                     gdouble* x,
                     gdouble* y)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	BezierPoint* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	BezierPoint* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
#line 109 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/Bezier.vala"
	_tmp0_ = self->priv->_to;
#line 110 "../src/Bezier.vala"
	_tmp1_ = bezier_point_get_x (_tmp0_);
#line 110 "../src/Bezier.vala"
	_tmp2_ = _tmp1_;
#line 110 "../src/Bezier.vala"
	_vala_x = _tmp2_;
#line 111 "../src/Bezier.vala"
	_tmp3_ = self->priv->_to;
#line 111 "../src/Bezier.vala"
	_tmp4_ = bezier_point_get_y (_tmp3_);
#line 111 "../src/Bezier.vala"
	_tmp5_ = _tmp4_;
#line 111 "../src/Bezier.vala"
	_vala_y = _tmp5_;
#line 109 "../src/Bezier.vala"
	if (x) {
#line 109 "../src/Bezier.vala"
		*x = _vala_x;
#line 796 "Bezier.c"
	}
#line 109 "../src/Bezier.vala"
	if (y) {
#line 109 "../src/Bezier.vala"
		*y = _vala_y;
#line 802 "Bezier.c"
	}
}

void
bezier_get_drag_point (Bezier* self,
                       gdouble* x,
                       gdouble* y)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	GArray* _tmp0_;
	BezierPoint* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GArray* _tmp4_;
	BezierPoint* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	GArray* _tmp8_;
	BezierPoint* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	GArray* _tmp12_;
	BezierPoint* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	GArray* _tmp16_;
	BezierPoint* _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	GArray* _tmp20_;
	BezierPoint* _tmp21_;
	gdouble _tmp22_;
	gdouble _tmp23_;
#line 114 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/Bezier.vala"
	_tmp0_ = self->priv->_points;
#line 115 "../src/Bezier.vala"
	_tmp1_ = g_array_index (_tmp0_, BezierPoint*, (guint) 1);
#line 115 "../src/Bezier.vala"
	_tmp2_ = bezier_point_get_x (_tmp1_);
#line 115 "../src/Bezier.vala"
	_tmp3_ = _tmp2_;
#line 115 "../src/Bezier.vala"
	_tmp4_ = self->priv->_points;
#line 115 "../src/Bezier.vala"
	_tmp5_ = g_array_index (_tmp4_, BezierPoint*, (guint) 0);
#line 115 "../src/Bezier.vala"
	_tmp6_ = bezier_point_get_x (_tmp5_);
#line 115 "../src/Bezier.vala"
	_tmp7_ = _tmp6_;
#line 115 "../src/Bezier.vala"
	_tmp8_ = self->priv->_points;
#line 115 "../src/Bezier.vala"
	_tmp9_ = g_array_index (_tmp8_, BezierPoint*, (guint) 2);
#line 115 "../src/Bezier.vala"
	_tmp10_ = bezier_point_get_x (_tmp9_);
#line 115 "../src/Bezier.vala"
	_tmp11_ = _tmp10_;
#line 115 "../src/Bezier.vala"
	_vala_x = ((_tmp3_ / 2) + (_tmp7_ / 4)) + (_tmp11_ / 4);
#line 116 "../src/Bezier.vala"
	_tmp12_ = self->priv->_points;
#line 116 "../src/Bezier.vala"
	_tmp13_ = g_array_index (_tmp12_, BezierPoint*, (guint) 1);
#line 116 "../src/Bezier.vala"
	_tmp14_ = bezier_point_get_y (_tmp13_);
#line 116 "../src/Bezier.vala"
	_tmp15_ = _tmp14_;
#line 116 "../src/Bezier.vala"
	_tmp16_ = self->priv->_points;
#line 116 "../src/Bezier.vala"
	_tmp17_ = g_array_index (_tmp16_, BezierPoint*, (guint) 0);
#line 116 "../src/Bezier.vala"
	_tmp18_ = bezier_point_get_y (_tmp17_);
#line 116 "../src/Bezier.vala"
	_tmp19_ = _tmp18_;
#line 116 "../src/Bezier.vala"
	_tmp20_ = self->priv->_points;
#line 116 "../src/Bezier.vala"
	_tmp21_ = g_array_index (_tmp20_, BezierPoint*, (guint) 2);
#line 116 "../src/Bezier.vala"
	_tmp22_ = bezier_point_get_y (_tmp21_);
#line 116 "../src/Bezier.vala"
	_tmp23_ = _tmp22_;
#line 116 "../src/Bezier.vala"
	_vala_y = ((_tmp15_ / 2) + (_tmp19_ / 4)) + (_tmp23_ / 4);
#line 114 "../src/Bezier.vala"
	if (x) {
#line 114 "../src/Bezier.vala"
		*x = _vala_x;
#line 895 "Bezier.c"
	}
#line 114 "../src/Bezier.vala"
	if (y) {
#line 114 "../src/Bezier.vala"
		*y = _vala_y;
#line 901 "Bezier.c"
	}
}

void
bezier_set_point (Bezier* self,
                  gint pindex,
                  gdouble x,
                  gdouble y)
{
	GArray* _tmp0_;
	BezierPoint* _tmp1_;
#line 120 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 121 "../src/Bezier.vala"
	_tmp0_ = self->priv->_points;
#line 121 "../src/Bezier.vala"
	_tmp1_ = g_array_index (_tmp0_, BezierPoint*, (guint) pindex);
#line 121 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp1_, x, y);
#line 921 "Bezier.c"
}

void
bezier_update_control_from_drag_handle (Bezier* self,
                                        gdouble x,
                                        gdouble y)
{
	gdouble cx = 0.0;
	GArray* _tmp0_;
	BezierPoint* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GArray* _tmp4_;
	BezierPoint* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble cy = 0.0;
	GArray* _tmp8_;
	BezierPoint* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	GArray* _tmp12_;
	BezierPoint* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
#line 124 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 125 "../src/Bezier.vala"
	_tmp0_ = self->priv->_points;
#line 125 "../src/Bezier.vala"
	_tmp1_ = g_array_index (_tmp0_, BezierPoint*, (guint) 0);
#line 125 "../src/Bezier.vala"
	_tmp2_ = bezier_point_get_x (_tmp1_);
#line 125 "../src/Bezier.vala"
	_tmp3_ = _tmp2_;
#line 125 "../src/Bezier.vala"
	_tmp4_ = self->priv->_points;
#line 125 "../src/Bezier.vala"
	_tmp5_ = g_array_index (_tmp4_, BezierPoint*, (guint) 2);
#line 125 "../src/Bezier.vala"
	_tmp6_ = bezier_point_get_x (_tmp5_);
#line 125 "../src/Bezier.vala"
	_tmp7_ = _tmp6_;
#line 125 "../src/Bezier.vala"
	cx = x - (((_tmp3_ + _tmp7_) * 0.5) - x);
#line 126 "../src/Bezier.vala"
	_tmp8_ = self->priv->_points;
#line 126 "../src/Bezier.vala"
	_tmp9_ = g_array_index (_tmp8_, BezierPoint*, (guint) 0);
#line 126 "../src/Bezier.vala"
	_tmp10_ = bezier_point_get_y (_tmp9_);
#line 126 "../src/Bezier.vala"
	_tmp11_ = _tmp10_;
#line 126 "../src/Bezier.vala"
	_tmp12_ = self->priv->_points;
#line 126 "../src/Bezier.vala"
	_tmp13_ = g_array_index (_tmp12_, BezierPoint*, (guint) 2);
#line 126 "../src/Bezier.vala"
	_tmp14_ = bezier_point_get_y (_tmp13_);
#line 126 "../src/Bezier.vala"
	_tmp15_ = _tmp14_;
#line 126 "../src/Bezier.vala"
	cy = y - (((_tmp11_ + _tmp15_) * 0.5) - y);
#line 127 "../src/Bezier.vala"
	bezier_set_point (self, 1, cx, cy);
#line 987 "Bezier.c"
}

static gboolean
bezier_is_t_within_range (Bezier* self,
                          gdouble t)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 131 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 132 "../src/Bezier.vala"
	if (((gdouble) 0) <= t) {
#line 132 "../src/Bezier.vala"
		_tmp0_ = t <= ((gdouble) 1);
#line 1002 "Bezier.c"
	} else {
#line 132 "../src/Bezier.vala"
		_tmp0_ = FALSE;
#line 1006 "Bezier.c"
	}
#line 132 "../src/Bezier.vala"
	result = _tmp0_;
#line 132 "../src/Bezier.vala"
	return result;
#line 1012 "Bezier.c"
}

static void
bezier_align_point (Bezier* self,
                    gint pindex,
                    gdouble a,
                    gdouble tx,
                    gdouble ty)
{
	gdouble x = 0.0;
	GArray* _tmp0_;
	BezierPoint* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GArray* _tmp4_;
	BezierPoint* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble y = 0.0;
	GArray* _tmp8_;
	BezierPoint* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	GArray* _tmp12_;
	BezierPoint* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	GArray* _tmp16_;
	BezierPoint* _tmp17_;
#line 136 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/Bezier.vala"
	_tmp0_ = self->priv->_points;
#line 137 "../src/Bezier.vala"
	_tmp1_ = g_array_index (_tmp0_, BezierPoint*, (guint) pindex);
#line 137 "../src/Bezier.vala"
	_tmp2_ = bezier_point_get_x (_tmp1_);
#line 137 "../src/Bezier.vala"
	_tmp3_ = _tmp2_;
#line 137 "../src/Bezier.vala"
	_tmp4_ = self->priv->_points;
#line 137 "../src/Bezier.vala"
	_tmp5_ = g_array_index (_tmp4_, BezierPoint*, (guint) pindex);
#line 137 "../src/Bezier.vala"
	_tmp6_ = bezier_point_get_y (_tmp5_);
#line 137 "../src/Bezier.vala"
	_tmp7_ = _tmp6_;
#line 137 "../src/Bezier.vala"
	x = ((_tmp3_ - tx) * cos (a)) - ((_tmp7_ - ty) * sin (a));
#line 138 "../src/Bezier.vala"
	_tmp8_ = self->priv->_points;
#line 138 "../src/Bezier.vala"
	_tmp9_ = g_array_index (_tmp8_, BezierPoint*, (guint) pindex);
#line 138 "../src/Bezier.vala"
	_tmp10_ = bezier_point_get_x (_tmp9_);
#line 138 "../src/Bezier.vala"
	_tmp11_ = _tmp10_;
#line 138 "../src/Bezier.vala"
	_tmp12_ = self->priv->_points;
#line 138 "../src/Bezier.vala"
	_tmp13_ = g_array_index (_tmp12_, BezierPoint*, (guint) pindex);
#line 138 "../src/Bezier.vala"
	_tmp14_ = bezier_point_get_y (_tmp13_);
#line 138 "../src/Bezier.vala"
	_tmp15_ = _tmp14_;
#line 138 "../src/Bezier.vala"
	y = ((_tmp11_ - tx) * sin (a)) + ((_tmp15_ - ty) * cos (a));
#line 139 "../src/Bezier.vala"
	_tmp16_ = self->priv->_apoints;
#line 139 "../src/Bezier.vala"
	_tmp17_ = g_array_index (_tmp16_, BezierPoint*, (guint) pindex);
#line 139 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp17_, x, y);
#line 1086 "Bezier.c"
}

static void
bezier_align (Bezier* self,
              gdouble lx0,
              gdouble ly0,
              gdouble lx1,
              gdouble ly1)
{
	gdouble tx = 0.0;
	gdouble ty = 0.0;
	gdouble a = 0.0;
#line 143 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/Bezier.vala"
	tx = lx0;
#line 146 "../src/Bezier.vala"
	ty = ly0;
#line 147 "../src/Bezier.vala"
	a = -atan2 (ly1 - ty, lx1 - tx);
#line 1107 "Bezier.c"
	{
		gint i = 0;
#line 149 "../src/Bezier.vala"
		i = 0;
#line 1112 "Bezier.c"
		{
			gboolean _tmp0_ = FALSE;
#line 149 "../src/Bezier.vala"
			_tmp0_ = TRUE;
#line 149 "../src/Bezier.vala"
			while (TRUE) {
#line 149 "../src/Bezier.vala"
				if (!_tmp0_) {
#line 1121 "Bezier.c"
					gint _tmp1_;
#line 149 "../src/Bezier.vala"
					_tmp1_ = i;
#line 149 "../src/Bezier.vala"
					i = _tmp1_ + 1;
#line 1127 "Bezier.c"
				}
#line 149 "../src/Bezier.vala"
				_tmp0_ = FALSE;
#line 149 "../src/Bezier.vala"
				if (!(i < 3)) {
#line 149 "../src/Bezier.vala"
					break;
#line 1135 "Bezier.c"
				}
#line 150 "../src/Bezier.vala"
				bezier_align_point (self, i, a, tx, ty);
#line 1139 "Bezier.c"
			}
		}
	}
}

static gdouble*
_double_dup (gdouble* self)
{
	gdouble* dup;
#line 174 "../src/Bezier.vala"
	dup = g_new0 (gdouble, 1);
#line 174 "../src/Bezier.vala"
	memcpy (dup, self, sizeof (gdouble));
#line 174 "../src/Bezier.vala"
	return dup;
#line 1155 "Bezier.c"
}

static gpointer
__double_dup0 (gpointer self)
{
#line 174 "../src/Bezier.vala"
	return self ? _double_dup (self) : NULL;
#line 1163 "Bezier.c"
}

static void
bezier_get_roots (Bezier* self,
                  gdouble axis,
                  gboolean axis_is_x,
                  GArray** roots)
{
	gdouble _tmp0_ = 0.0;
	gdouble lx0 = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble ly0 = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble lx1 = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble ly1 = 0.0;
	gdouble a = 0.0;
	GArray* _tmp4_;
	BezierPoint* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble b = 0.0;
	GArray* _tmp8_;
	BezierPoint* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble c = 0.0;
	GArray* _tmp12_;
	BezierPoint* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble d = 0.0;
#line 156 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/Bezier.vala"
	g_return_if_fail (*roots != NULL);
#line 158 "../src/Bezier.vala"
	if (axis_is_x) {
#line 158 "../src/Bezier.vala"
		_tmp0_ = axis;
#line 1204 "Bezier.c"
	} else {
#line 158 "../src/Bezier.vala"
		_tmp0_ = (gdouble) 0;
#line 1208 "Bezier.c"
	}
#line 158 "../src/Bezier.vala"
	lx0 = _tmp0_;
#line 159 "../src/Bezier.vala"
	if (axis_is_x) {
#line 159 "../src/Bezier.vala"
		_tmp1_ = (gdouble) 0;
#line 1216 "Bezier.c"
	} else {
#line 159 "../src/Bezier.vala"
		_tmp1_ = axis;
#line 1220 "Bezier.c"
	}
#line 159 "../src/Bezier.vala"
	ly0 = _tmp1_;
#line 160 "../src/Bezier.vala"
	if (axis_is_x) {
#line 160 "../src/Bezier.vala"
		_tmp2_ = axis;
#line 1228 "Bezier.c"
	} else {
#line 160 "../src/Bezier.vala"
		_tmp2_ = (gdouble) 1000000;
#line 1232 "Bezier.c"
	}
#line 160 "../src/Bezier.vala"
	lx1 = _tmp2_;
#line 161 "../src/Bezier.vala"
	if (axis_is_x) {
#line 161 "../src/Bezier.vala"
		_tmp3_ = (gdouble) 1000000;
#line 1240 "Bezier.c"
	} else {
#line 161 "../src/Bezier.vala"
		_tmp3_ = axis;
#line 1244 "Bezier.c"
	}
#line 161 "../src/Bezier.vala"
	ly1 = _tmp3_;
#line 162 "../src/Bezier.vala"
	bezier_align (self, lx0, ly0, lx1, ly1);
#line 164 "../src/Bezier.vala"
	_tmp4_ = self->priv->_apoints;
#line 164 "../src/Bezier.vala"
	_tmp5_ = g_array_index (_tmp4_, BezierPoint*, (guint) 0);
#line 164 "../src/Bezier.vala"
	_tmp6_ = bezier_point_get_y (_tmp5_);
#line 164 "../src/Bezier.vala"
	_tmp7_ = _tmp6_;
#line 164 "../src/Bezier.vala"
	a = _tmp7_;
#line 165 "../src/Bezier.vala"
	_tmp8_ = self->priv->_apoints;
#line 165 "../src/Bezier.vala"
	_tmp9_ = g_array_index (_tmp8_, BezierPoint*, (guint) 1);
#line 165 "../src/Bezier.vala"
	_tmp10_ = bezier_point_get_y (_tmp9_);
#line 165 "../src/Bezier.vala"
	_tmp11_ = _tmp10_;
#line 165 "../src/Bezier.vala"
	b = _tmp11_;
#line 166 "../src/Bezier.vala"
	_tmp12_ = self->priv->_apoints;
#line 166 "../src/Bezier.vala"
	_tmp13_ = g_array_index (_tmp12_, BezierPoint*, (guint) 2);
#line 166 "../src/Bezier.vala"
	_tmp14_ = bezier_point_get_y (_tmp13_);
#line 166 "../src/Bezier.vala"
	_tmp15_ = _tmp14_;
#line 166 "../src/Bezier.vala"
	c = _tmp15_;
#line 167 "../src/Bezier.vala"
	d = (a - (2 * b)) + c;
#line 169 "../src/Bezier.vala"
	if (d != ((gdouble) 0)) {
#line 1284 "Bezier.c"
		gdouble m1 = 0.0;
		gdouble m2 = 0.0;
		gdouble v1 = 0.0;
		gdouble v2 = 0.0;
#line 170 "../src/Bezier.vala"
		m1 = -sqrt ((b * b) - (a * c));
#line 171 "../src/Bezier.vala"
		m2 = (-a) + b;
#line 172 "../src/Bezier.vala"
		v1 = (-(m1 + m2)) / d;
#line 173 "../src/Bezier.vala"
		v2 = (-((-m1) + m2)) / d;
#line 174 "../src/Bezier.vala"
		if (bezier_is_t_within_range (self, v1)) {
#line 1299 "Bezier.c"
			gdouble* _tmp16_;
#line 174 "../src/Bezier.vala"
			_tmp16_ = __double_dup0 (&v1);
#line 174 "../src/Bezier.vala"
			g_array_append_val (*roots, _tmp16_);
#line 1305 "Bezier.c"
		}
#line 175 "../src/Bezier.vala"
		if (bezier_is_t_within_range (self, v2)) {
#line 1309 "Bezier.c"
			gdouble* _tmp17_;
#line 175 "../src/Bezier.vala"
			_tmp17_ = __double_dup0 (&v2);
#line 175 "../src/Bezier.vala"
			g_array_append_val (*roots, _tmp17_);
#line 1315 "Bezier.c"
		}
	} else {
#line 176 "../src/Bezier.vala"
		if (b != c) {
#line 1320 "Bezier.c"
			gdouble v = 0.0;
#line 177 "../src/Bezier.vala"
			v = ((2 * b) - c) / (2 * (b - c));
#line 178 "../src/Bezier.vala"
			if (bezier_is_t_within_range (self, v)) {
#line 1326 "Bezier.c"
				gdouble* _tmp18_;
#line 178 "../src/Bezier.vala"
				_tmp18_ = __double_dup0 (&v);
#line 178 "../src/Bezier.vala"
				g_array_append_val (*roots, _tmp18_);
#line 1332 "Bezier.c"
			}
		}
	}
}

static gdouble
bezier_get_axis (Bezier* self,
                 gdouble t,
                 gboolean axis_is_x)
{
	gdouble mt = 0.0;
	gdouble mt2 = 0.0;
	gdouble t2 = 0.0;
	gdouble a = 0.0;
	gdouble b = 0.0;
	gdouble c = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp18_ = 0.0;
	gdouble axis = 0.0;
	gdouble result;
#line 183 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 185 "../src/Bezier.vala"
	mt = 1 - t;
#line 186 "../src/Bezier.vala"
	mt2 = mt * mt;
#line 187 "../src/Bezier.vala"
	t2 = t * t;
#line 188 "../src/Bezier.vala"
	a = mt2;
#line 189 "../src/Bezier.vala"
	b = (mt * t) * 2;
#line 190 "../src/Bezier.vala"
	c = t2;
#line 191 "../src/Bezier.vala"
	if (axis_is_x) {
#line 1370 "Bezier.c"
		GArray* _tmp1_;
		BezierPoint* _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
#line 191 "../src/Bezier.vala"
		_tmp1_ = self->priv->_points;
#line 191 "../src/Bezier.vala"
		_tmp2_ = g_array_index (_tmp1_, BezierPoint*, (guint) 0);
#line 191 "../src/Bezier.vala"
		_tmp3_ = bezier_point_get_y (_tmp2_);
#line 191 "../src/Bezier.vala"
		_tmp4_ = _tmp3_;
#line 191 "../src/Bezier.vala"
		_tmp0_ = _tmp4_;
#line 1385 "Bezier.c"
	} else {
		GArray* _tmp5_;
		BezierPoint* _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
#line 191 "../src/Bezier.vala"
		_tmp5_ = self->priv->_points;
#line 191 "../src/Bezier.vala"
		_tmp6_ = g_array_index (_tmp5_, BezierPoint*, (guint) 0);
#line 191 "../src/Bezier.vala"
		_tmp7_ = bezier_point_get_x (_tmp6_);
#line 191 "../src/Bezier.vala"
		_tmp8_ = _tmp7_;
#line 191 "../src/Bezier.vala"
		_tmp0_ = _tmp8_;
#line 1401 "Bezier.c"
	}
#line 192 "../src/Bezier.vala"
	if (axis_is_x) {
#line 1405 "Bezier.c"
		GArray* _tmp10_;
		BezierPoint* _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
#line 192 "../src/Bezier.vala"
		_tmp10_ = self->priv->_points;
#line 192 "../src/Bezier.vala"
		_tmp11_ = g_array_index (_tmp10_, BezierPoint*, (guint) 1);
#line 192 "../src/Bezier.vala"
		_tmp12_ = bezier_point_get_y (_tmp11_);
#line 192 "../src/Bezier.vala"
		_tmp13_ = _tmp12_;
#line 192 "../src/Bezier.vala"
		_tmp9_ = _tmp13_;
#line 1420 "Bezier.c"
	} else {
		GArray* _tmp14_;
		BezierPoint* _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
#line 192 "../src/Bezier.vala"
		_tmp14_ = self->priv->_points;
#line 192 "../src/Bezier.vala"
		_tmp15_ = g_array_index (_tmp14_, BezierPoint*, (guint) 1);
#line 192 "../src/Bezier.vala"
		_tmp16_ = bezier_point_get_x (_tmp15_);
#line 192 "../src/Bezier.vala"
		_tmp17_ = _tmp16_;
#line 192 "../src/Bezier.vala"
		_tmp9_ = _tmp17_;
#line 1436 "Bezier.c"
	}
#line 193 "../src/Bezier.vala"
	if (axis_is_x) {
#line 1440 "Bezier.c"
		GArray* _tmp19_;
		BezierPoint* _tmp20_;
		gdouble _tmp21_;
		gdouble _tmp22_;
#line 193 "../src/Bezier.vala"
		_tmp19_ = self->priv->_points;
#line 193 "../src/Bezier.vala"
		_tmp20_ = g_array_index (_tmp19_, BezierPoint*, (guint) 2);
#line 193 "../src/Bezier.vala"
		_tmp21_ = bezier_point_get_y (_tmp20_);
#line 193 "../src/Bezier.vala"
		_tmp22_ = _tmp21_;
#line 193 "../src/Bezier.vala"
		_tmp18_ = _tmp22_;
#line 1455 "Bezier.c"
	} else {
		GArray* _tmp23_;
		BezierPoint* _tmp24_;
		gdouble _tmp25_;
		gdouble _tmp26_;
#line 193 "../src/Bezier.vala"
		_tmp23_ = self->priv->_points;
#line 193 "../src/Bezier.vala"
		_tmp24_ = g_array_index (_tmp23_, BezierPoint*, (guint) 2);
#line 193 "../src/Bezier.vala"
		_tmp25_ = bezier_point_get_x (_tmp24_);
#line 193 "../src/Bezier.vala"
		_tmp26_ = _tmp25_;
#line 193 "../src/Bezier.vala"
		_tmp18_ = _tmp26_;
#line 1471 "Bezier.c"
	}
#line 191 "../src/Bezier.vala"
	axis = ((a * _tmp0_) + (b * _tmp9_)) + (c * _tmp18_);
#line 195 "../src/Bezier.vala"
	result = axis;
#line 195 "../src/Bezier.vala"
	return result;
#line 1479 "Bezier.c"
}

static void
_g_free0_ (gpointer var)
{
#line 202 "../src/Bezier.vala"
	(var == NULL) ? NULL : (var = (g_free (var), NULL));
#line 1487 "Bezier.c"
}

static void
_vala_gdouble_free_function_content_of (gpointer data)
{
	gdouble* self;
#line 202 "../src/Bezier.vala"
	self = *((gdouble**) data);
#line 202 "../src/Bezier.vala"
	_g_free0_ (self);
#line 1498 "Bezier.c"
}

static gpointer*
vala_g_array_remove_range (GArray* self,
                           guint index,
                           guint length,
                           gint* result_length1)
{
	gpointer* ga = NULL;
	gpointer* _tmp0_;
	gint ga_length1;
	gint _ga_size_;
	gpointer* _tmp6_;
	gint _tmp6__length1;
	gpointer* result;
#line 6196 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 6197 "glib-2.0.vapi"
	_vala_assert (self->len >= (index + length), "this.length >= index + length");
#line 6198 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gpointer, length);
#line 6198 "glib-2.0.vapi"
	ga = _tmp0_;
#line 6198 "glib-2.0.vapi"
	ga_length1 = length;
#line 6198 "glib-2.0.vapi"
	_ga_size_ = ga_length1;
#line 1526 "Bezier.c"
	{
		guint i = 0U;
#line 6199 "glib-2.0.vapi"
		i = (guint) 0;
#line 1531 "Bezier.c"
		{
			gboolean _tmp1_ = FALSE;
#line 6199 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 6199 "glib-2.0.vapi"
			while (TRUE) {
#line 1538 "Bezier.c"
				gpointer* _tmp3_;
				gint _tmp3__length1;
				gpointer* _tmp4_;
				gint _tmp4__length1;
				gpointer _tmp5_;
#line 6199 "glib-2.0.vapi"
				if (!_tmp1_) {
#line 1546 "Bezier.c"
					guint _tmp2_;
#line 6199 "glib-2.0.vapi"
					_tmp2_ = i;
#line 6199 "glib-2.0.vapi"
					i = _tmp2_ + 1;
#line 1552 "Bezier.c"
				}
#line 6199 "glib-2.0.vapi"
				_tmp1_ = FALSE;
#line 6199 "glib-2.0.vapi"
				if (!(i < length)) {
#line 6199 "glib-2.0.vapi"
					break;
#line 1560 "Bezier.c"
				}
#line 6200 "glib-2.0.vapi"
				_tmp3_ = ga;
#line 6200 "glib-2.0.vapi"
				_tmp3__length1 = ga_length1;
#line 6200 "glib-2.0.vapi"
				_tmp4_ = self->data;
#line 6200 "glib-2.0.vapi"
				_tmp4__length1 = self->len;
#line 6200 "glib-2.0.vapi"
				_tmp5_ = _tmp4_[i + index];
#line 6200 "glib-2.0.vapi"
				_tmp4_[i + index] = NULL;
#line 6200 "glib-2.0.vapi"
				_tmp3_[i] = _tmp5_;
#line 1576 "Bezier.c"
			}
		}
	}
#line 6202 "glib-2.0.vapi"
	g_array_remove_range (self, index, length);
#line 6203 "glib-2.0.vapi"
	_tmp6_ = ga;
#line 6203 "glib-2.0.vapi"
	_tmp6__length1 = ga_length1;
#line 6203 "glib-2.0.vapi"
	if (result_length1) {
#line 6203 "glib-2.0.vapi"
		*result_length1 = _tmp6__length1;
#line 1590 "Bezier.c"
	}
#line 6203 "glib-2.0.vapi"
	result = _tmp6_;
#line 6203 "glib-2.0.vapi"
	return result;
#line 1596 "Bezier.c"
}

gboolean
bezier_within_range (Bezier* self,
                     gdouble x,
                     gdouble y)
{
	GArray* roots = NULL;
	GArray* _tmp0_;
	gdouble tolerance = 0.0;
	GArray* _tmp1_;
	GArray* _tmp7_;
	GArray* _tmp8_;
	gint _tmp9_ = 0;
	gpointer* _tmp10_;
	gdouble** _tmp11_;
	gint _tmp11__length1;
	gboolean result;
#line 200 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 202 "../src/Bezier.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (gdouble*));
#line 202 "../src/Bezier.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_gdouble_free_function_content_of);
#line 202 "../src/Bezier.vala"
	roots = _tmp0_;
#line 203 "../src/Bezier.vala"
	tolerance = (gdouble) 10;
#line 206 "../src/Bezier.vala"
	bezier_get_roots (self, x, TRUE, &roots);
#line 208 "../src/Bezier.vala"
	_tmp1_ = roots;
#line 208 "../src/Bezier.vala"
	if (_tmp1_->len > ((guint) 0)) {
#line 1631 "Bezier.c"
		{
			gint i = 0;
#line 209 "../src/Bezier.vala"
			i = 0;
#line 1636 "Bezier.c"
			{
				gboolean _tmp2_ = FALSE;
#line 209 "../src/Bezier.vala"
				_tmp2_ = TRUE;
#line 209 "../src/Bezier.vala"
				while (TRUE) {
#line 1643 "Bezier.c"
					GArray* _tmp4_;
					gdouble curve_y = 0.0;
					GArray* _tmp5_;
					gboolean _tmp6_ = FALSE;
#line 209 "../src/Bezier.vala"
					if (!_tmp2_) {
#line 1650 "Bezier.c"
						gint _tmp3_;
#line 209 "../src/Bezier.vala"
						_tmp3_ = i;
#line 209 "../src/Bezier.vala"
						i = _tmp3_ + 1;
#line 1656 "Bezier.c"
					}
#line 209 "../src/Bezier.vala"
					_tmp2_ = FALSE;
#line 209 "../src/Bezier.vala"
					_tmp4_ = roots;
#line 209 "../src/Bezier.vala"
					if (!(((guint) i) < _tmp4_->len)) {
#line 209 "../src/Bezier.vala"
						break;
#line 1666 "Bezier.c"
					}
#line 210 "../src/Bezier.vala"
					_tmp5_ = roots;
#line 210 "../src/Bezier.vala"
					curve_y = bezier_get_axis (self, *g_array_index (_tmp5_, gdouble*, (guint) i), TRUE);
#line 211 "../src/Bezier.vala"
					if ((curve_y - tolerance) <= y) {
#line 211 "../src/Bezier.vala"
						_tmp6_ = y <= (curve_y + tolerance);
#line 1676 "Bezier.c"
					} else {
#line 211 "../src/Bezier.vala"
						_tmp6_ = FALSE;
#line 1680 "Bezier.c"
					}
#line 211 "../src/Bezier.vala"
					if (_tmp6_) {
#line 212 "../src/Bezier.vala"
						result = TRUE;
#line 212 "../src/Bezier.vala"
						_g_array_unref0 (roots);
#line 212 "../src/Bezier.vala"
						return result;
#line 1690 "Bezier.c"
					}
				}
			}
		}
	}
#line 218 "../src/Bezier.vala"
	_tmp7_ = roots;
#line 218 "../src/Bezier.vala"
	_tmp8_ = roots;
#line 218 "../src/Bezier.vala"
	_tmp10_ = vala_g_array_remove_range (_tmp7_, (guint) 0, _tmp8_->len, &_tmp9_);
#line 218 "../src/Bezier.vala"
	_tmp11_ = _tmp10_;
#line 218 "../src/Bezier.vala"
	_tmp11__length1 = _tmp9_;
#line 218 "../src/Bezier.vala"
	_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 219 "../src/Bezier.vala"
	bezier_get_roots (self, y, FALSE, &roots);
#line 1710 "Bezier.c"
	{
		gint i = 0;
#line 221 "../src/Bezier.vala"
		i = 0;
#line 1715 "Bezier.c"
		{
			gboolean _tmp12_ = FALSE;
#line 221 "../src/Bezier.vala"
			_tmp12_ = TRUE;
#line 221 "../src/Bezier.vala"
			while (TRUE) {
#line 1722 "Bezier.c"
				GArray* _tmp14_;
				gdouble curve_x = 0.0;
				GArray* _tmp15_;
				gboolean _tmp16_ = FALSE;
#line 221 "../src/Bezier.vala"
				if (!_tmp12_) {
#line 1729 "Bezier.c"
					gint _tmp13_;
#line 221 "../src/Bezier.vala"
					_tmp13_ = i;
#line 221 "../src/Bezier.vala"
					i = _tmp13_ + 1;
#line 1735 "Bezier.c"
				}
#line 221 "../src/Bezier.vala"
				_tmp12_ = FALSE;
#line 221 "../src/Bezier.vala"
				_tmp14_ = roots;
#line 221 "../src/Bezier.vala"
				if (!(((guint) i) < _tmp14_->len)) {
#line 221 "../src/Bezier.vala"
					break;
#line 1745 "Bezier.c"
				}
#line 222 "../src/Bezier.vala"
				_tmp15_ = roots;
#line 222 "../src/Bezier.vala"
				curve_x = bezier_get_axis (self, *g_array_index (_tmp15_, gdouble*, (guint) i), FALSE);
#line 223 "../src/Bezier.vala"
				if ((curve_x - tolerance) <= x) {
#line 223 "../src/Bezier.vala"
					_tmp16_ = x <= (curve_x + tolerance);
#line 1755 "Bezier.c"
				} else {
#line 223 "../src/Bezier.vala"
					_tmp16_ = FALSE;
#line 1759 "Bezier.c"
				}
#line 223 "../src/Bezier.vala"
				if (_tmp16_) {
#line 224 "../src/Bezier.vala"
					result = TRUE;
#line 224 "../src/Bezier.vala"
					_g_array_unref0 (roots);
#line 224 "../src/Bezier.vala"
					return result;
#line 1769 "Bezier.c"
				}
			}
		}
	}
#line 228 "../src/Bezier.vala"
	result = FALSE;
#line 228 "../src/Bezier.vala"
	_g_array_unref0 (roots);
#line 228 "../src/Bezier.vala"
	return result;
#line 1780 "Bezier.c"
}

gdouble*
bezier_get_intersecting_point (Bezier* self,
                               gdouble axis,
                               gboolean axis_is_x,
                               gboolean from)
{
	GArray* roots = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	gdouble* result;
#line 233 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 235 "../src/Bezier.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (gdouble*));
#line 235 "../src/Bezier.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_gdouble_free_function_content_of);
#line 235 "../src/Bezier.vala"
	roots = _tmp0_;
#line 237 "../src/Bezier.vala"
	bezier_get_roots (self, axis, axis_is_x, &roots);
#line 239 "../src/Bezier.vala"
	_tmp1_ = roots;
#line 239 "../src/Bezier.vala"
	switch (_tmp1_->len) {
#line 239 "../src/Bezier.vala"
		case 0:
#line 1809 "Bezier.c"
		{
#line 240 "../src/Bezier.vala"
			result = NULL;
#line 240 "../src/Bezier.vala"
			_g_array_unref0 (roots);
#line 240 "../src/Bezier.vala"
			return result;
#line 1817 "Bezier.c"
		}
#line 239 "../src/Bezier.vala"
		case 1:
#line 1821 "Bezier.c"
		{
			GArray* _tmp2_;
			gdouble _tmp3_;
			gdouble* _tmp4_;
#line 242 "../src/Bezier.vala"
			_tmp2_ = roots;
#line 242 "../src/Bezier.vala"
			_tmp3_ = bezier_get_axis (self, *g_array_index (_tmp2_, gdouble*, (guint) 0), axis_is_x);
#line 242 "../src/Bezier.vala"
			_tmp4_ = __double_dup0 (&_tmp3_);
#line 242 "../src/Bezier.vala"
			result = _tmp4_;
#line 242 "../src/Bezier.vala"
			_g_array_unref0 (roots);
#line 242 "../src/Bezier.vala"
			return result;
#line 1838 "Bezier.c"
		}
		default:
		{
#line 244 "../src/Bezier.vala"
			if (from) {
#line 1844 "Bezier.c"
				gdouble max = 0.0;
				gdouble _tmp10_;
				gdouble* _tmp11_;
#line 245 "../src/Bezier.vala"
				max = (gdouble) 1000000;
#line 1850 "Bezier.c"
				{
					gint i = 0;
#line 246 "../src/Bezier.vala"
					i = 0;
#line 1855 "Bezier.c"
					{
						gboolean _tmp5_ = FALSE;
#line 246 "../src/Bezier.vala"
						_tmp5_ = TRUE;
#line 246 "../src/Bezier.vala"
						while (TRUE) {
#line 1862 "Bezier.c"
							GArray* _tmp7_;
							GArray* _tmp8_;
#line 246 "../src/Bezier.vala"
							if (!_tmp5_) {
#line 1867 "Bezier.c"
								gint _tmp6_;
#line 246 "../src/Bezier.vala"
								_tmp6_ = i;
#line 246 "../src/Bezier.vala"
								i = _tmp6_ + 1;
#line 1873 "Bezier.c"
							}
#line 246 "../src/Bezier.vala"
							_tmp5_ = FALSE;
#line 246 "../src/Bezier.vala"
							_tmp7_ = roots;
#line 246 "../src/Bezier.vala"
							if (!(((guint) i) < _tmp7_->len)) {
#line 246 "../src/Bezier.vala"
								break;
#line 1883 "Bezier.c"
							}
#line 247 "../src/Bezier.vala"
							_tmp8_ = roots;
#line 247 "../src/Bezier.vala"
							if ((*g_array_index (_tmp8_, gdouble*, (guint) i)) < max) {
#line 1889 "Bezier.c"
								GArray* _tmp9_;
#line 248 "../src/Bezier.vala"
								_tmp9_ = roots;
#line 248 "../src/Bezier.vala"
								max = *g_array_index (_tmp9_, gdouble*, (guint) i);
#line 1895 "Bezier.c"
							}
						}
					}
				}
#line 251 "../src/Bezier.vala"
				_tmp10_ = bezier_get_axis (self, max, axis_is_x);
#line 251 "../src/Bezier.vala"
				_tmp11_ = __double_dup0 (&_tmp10_);
#line 251 "../src/Bezier.vala"
				result = _tmp11_;
#line 251 "../src/Bezier.vala"
				_g_array_unref0 (roots);
#line 251 "../src/Bezier.vala"
				return result;
#line 1910 "Bezier.c"
			} else {
				gdouble min = 0.0;
				gdouble _tmp17_;
				gdouble* _tmp18_;
#line 253 "../src/Bezier.vala"
				min = (gdouble) 0;
#line 1917 "Bezier.c"
				{
					gint i = 0;
#line 254 "../src/Bezier.vala"
					i = 0;
#line 1922 "Bezier.c"
					{
						gboolean _tmp12_ = FALSE;
#line 254 "../src/Bezier.vala"
						_tmp12_ = TRUE;
#line 254 "../src/Bezier.vala"
						while (TRUE) {
#line 1929 "Bezier.c"
							GArray* _tmp14_;
							GArray* _tmp15_;
#line 254 "../src/Bezier.vala"
							if (!_tmp12_) {
#line 1934 "Bezier.c"
								gint _tmp13_;
#line 254 "../src/Bezier.vala"
								_tmp13_ = i;
#line 254 "../src/Bezier.vala"
								i = _tmp13_ + 1;
#line 1940 "Bezier.c"
							}
#line 254 "../src/Bezier.vala"
							_tmp12_ = FALSE;
#line 254 "../src/Bezier.vala"
							_tmp14_ = roots;
#line 254 "../src/Bezier.vala"
							if (!(((guint) i) < _tmp14_->len)) {
#line 254 "../src/Bezier.vala"
								break;
#line 1950 "Bezier.c"
							}
#line 255 "../src/Bezier.vala"
							_tmp15_ = roots;
#line 255 "../src/Bezier.vala"
							if ((*g_array_index (_tmp15_, gdouble*, (guint) i)) > min) {
#line 1956 "Bezier.c"
								GArray* _tmp16_;
#line 256 "../src/Bezier.vala"
								_tmp16_ = roots;
#line 256 "../src/Bezier.vala"
								min = *g_array_index (_tmp16_, gdouble*, (guint) i);
#line 1962 "Bezier.c"
							}
						}
					}
				}
#line 259 "../src/Bezier.vala"
				_tmp17_ = bezier_get_axis (self, min, axis_is_x);
#line 259 "../src/Bezier.vala"
				_tmp18_ = __double_dup0 (&_tmp17_);
#line 259 "../src/Bezier.vala"
				result = _tmp18_;
#line 259 "../src/Bezier.vala"
				_g_array_unref0 (roots);
#line 259 "../src/Bezier.vala"
				return result;
#line 1977 "Bezier.c"
			}
		}
	}
}

void
bezier_set_connect_point (Bezier* self,
                          gboolean from,
                          gdouble top,
                          gdouble bottom,
                          gdouble left,
                          gdouble right)
{
	gdouble* isect = NULL;
	gdouble* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gdouble* _tmp3_;
	gdouble* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gdouble* _tmp13_;
	gdouble* _tmp20_;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gdouble* _tmp23_;
	gdouble* _tmp30_;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gdouble* _tmp33_;
#line 266 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/Bezier.vala"
	_tmp0_ = bezier_get_intersecting_point (self, top, FALSE, from);
#line 271 "../src/Bezier.vala"
	_g_free0 (isect);
#line 271 "../src/Bezier.vala"
	isect = _tmp0_;
#line 272 "../src/Bezier.vala"
	_tmp3_ = isect;
#line 272 "../src/Bezier.vala"
	if (_tmp3_ != NULL) {
#line 2020 "Bezier.c"
		gdouble* _tmp4_;
#line 272 "../src/Bezier.vala"
		_tmp4_ = isect;
#line 272 "../src/Bezier.vala"
		_tmp2_ = left <= (*_tmp4_);
#line 2026 "Bezier.c"
	} else {
#line 272 "../src/Bezier.vala"
		_tmp2_ = FALSE;
#line 2030 "Bezier.c"
	}
#line 272 "../src/Bezier.vala"
	if (_tmp2_) {
#line 2034 "Bezier.c"
		gdouble* _tmp5_;
#line 272 "../src/Bezier.vala"
		_tmp5_ = isect;
#line 272 "../src/Bezier.vala"
		_tmp1_ = (*_tmp5_) <= right;
#line 2040 "Bezier.c"
	} else {
#line 272 "../src/Bezier.vala"
		_tmp1_ = FALSE;
#line 2044 "Bezier.c"
	}
#line 272 "../src/Bezier.vala"
	if (_tmp1_) {
#line 273 "../src/Bezier.vala"
		if (from) {
#line 2050 "Bezier.c"
			BezierPoint* _tmp6_;
			gdouble* _tmp7_;
#line 273 "../src/Bezier.vala"
			_tmp6_ = self->priv->_from;
#line 273 "../src/Bezier.vala"
			_tmp7_ = isect;
#line 273 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp6_, *_tmp7_, top);
#line 2059 "Bezier.c"
		} else {
			BezierPoint* _tmp8_;
			gdouble* _tmp9_;
#line 273 "../src/Bezier.vala"
			_tmp8_ = self->priv->_to;
#line 273 "../src/Bezier.vala"
			_tmp9_ = isect;
#line 273 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp8_, *_tmp9_, top);
#line 2069 "Bezier.c"
		}
#line 274 "../src/Bezier.vala"
		_g_free0 (isect);
#line 274 "../src/Bezier.vala"
		return;
#line 2075 "Bezier.c"
	}
#line 278 "../src/Bezier.vala"
	_tmp10_ = bezier_get_intersecting_point (self, bottom, FALSE, from);
#line 278 "../src/Bezier.vala"
	_g_free0 (isect);
#line 278 "../src/Bezier.vala"
	isect = _tmp10_;
#line 279 "../src/Bezier.vala"
	_tmp13_ = isect;
#line 279 "../src/Bezier.vala"
	if (_tmp13_ != NULL) {
#line 2087 "Bezier.c"
		gdouble* _tmp14_;
#line 279 "../src/Bezier.vala"
		_tmp14_ = isect;
#line 279 "../src/Bezier.vala"
		_tmp12_ = left <= (*_tmp14_);
#line 2093 "Bezier.c"
	} else {
#line 279 "../src/Bezier.vala"
		_tmp12_ = FALSE;
#line 2097 "Bezier.c"
	}
#line 279 "../src/Bezier.vala"
	if (_tmp12_) {
#line 2101 "Bezier.c"
		gdouble* _tmp15_;
#line 279 "../src/Bezier.vala"
		_tmp15_ = isect;
#line 279 "../src/Bezier.vala"
		_tmp11_ = (*_tmp15_) <= right;
#line 2107 "Bezier.c"
	} else {
#line 279 "../src/Bezier.vala"
		_tmp11_ = FALSE;
#line 2111 "Bezier.c"
	}
#line 279 "../src/Bezier.vala"
	if (_tmp11_) {
#line 280 "../src/Bezier.vala"
		if (from) {
#line 2117 "Bezier.c"
			BezierPoint* _tmp16_;
			gdouble* _tmp17_;
#line 280 "../src/Bezier.vala"
			_tmp16_ = self->priv->_from;
#line 280 "../src/Bezier.vala"
			_tmp17_ = isect;
#line 280 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp16_, *_tmp17_, bottom);
#line 2126 "Bezier.c"
		} else {
			BezierPoint* _tmp18_;
			gdouble* _tmp19_;
#line 280 "../src/Bezier.vala"
			_tmp18_ = self->priv->_to;
#line 280 "../src/Bezier.vala"
			_tmp19_ = isect;
#line 280 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp18_, *_tmp19_, bottom);
#line 2136 "Bezier.c"
		}
#line 281 "../src/Bezier.vala"
		_g_free0 (isect);
#line 281 "../src/Bezier.vala"
		return;
#line 2142 "Bezier.c"
	}
#line 285 "../src/Bezier.vala"
	_tmp20_ = bezier_get_intersecting_point (self, left, TRUE, from);
#line 285 "../src/Bezier.vala"
	_g_free0 (isect);
#line 285 "../src/Bezier.vala"
	isect = _tmp20_;
#line 286 "../src/Bezier.vala"
	_tmp23_ = isect;
#line 286 "../src/Bezier.vala"
	if (_tmp23_ != NULL) {
#line 2154 "Bezier.c"
		gdouble* _tmp24_;
#line 286 "../src/Bezier.vala"
		_tmp24_ = isect;
#line 286 "../src/Bezier.vala"
		_tmp22_ = top <= (*_tmp24_);
#line 2160 "Bezier.c"
	} else {
#line 286 "../src/Bezier.vala"
		_tmp22_ = FALSE;
#line 2164 "Bezier.c"
	}
#line 286 "../src/Bezier.vala"
	if (_tmp22_) {
#line 2168 "Bezier.c"
		gdouble* _tmp25_;
#line 286 "../src/Bezier.vala"
		_tmp25_ = isect;
#line 286 "../src/Bezier.vala"
		_tmp21_ = (*_tmp25_) <= bottom;
#line 2174 "Bezier.c"
	} else {
#line 286 "../src/Bezier.vala"
		_tmp21_ = FALSE;
#line 2178 "Bezier.c"
	}
#line 286 "../src/Bezier.vala"
	if (_tmp21_) {
#line 287 "../src/Bezier.vala"
		if (from) {
#line 2184 "Bezier.c"
			BezierPoint* _tmp26_;
			gdouble* _tmp27_;
#line 287 "../src/Bezier.vala"
			_tmp26_ = self->priv->_from;
#line 287 "../src/Bezier.vala"
			_tmp27_ = isect;
#line 287 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp26_, left, *_tmp27_);
#line 2193 "Bezier.c"
		} else {
			BezierPoint* _tmp28_;
			gdouble* _tmp29_;
#line 287 "../src/Bezier.vala"
			_tmp28_ = self->priv->_to;
#line 287 "../src/Bezier.vala"
			_tmp29_ = isect;
#line 287 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp28_, left, *_tmp29_);
#line 2203 "Bezier.c"
		}
#line 288 "../src/Bezier.vala"
		_g_free0 (isect);
#line 288 "../src/Bezier.vala"
		return;
#line 2209 "Bezier.c"
	}
#line 292 "../src/Bezier.vala"
	_tmp30_ = bezier_get_intersecting_point (self, right, TRUE, from);
#line 292 "../src/Bezier.vala"
	_g_free0 (isect);
#line 292 "../src/Bezier.vala"
	isect = _tmp30_;
#line 293 "../src/Bezier.vala"
	_tmp33_ = isect;
#line 293 "../src/Bezier.vala"
	if (_tmp33_ != NULL) {
#line 2221 "Bezier.c"
		gdouble* _tmp34_;
#line 293 "../src/Bezier.vala"
		_tmp34_ = isect;
#line 293 "../src/Bezier.vala"
		_tmp32_ = top <= (*_tmp34_);
#line 2227 "Bezier.c"
	} else {
#line 293 "../src/Bezier.vala"
		_tmp32_ = FALSE;
#line 2231 "Bezier.c"
	}
#line 293 "../src/Bezier.vala"
	if (_tmp32_) {
#line 2235 "Bezier.c"
		gdouble* _tmp35_;
#line 293 "../src/Bezier.vala"
		_tmp35_ = isect;
#line 293 "../src/Bezier.vala"
		_tmp31_ = (*_tmp35_) <= bottom;
#line 2241 "Bezier.c"
	} else {
#line 293 "../src/Bezier.vala"
		_tmp31_ = FALSE;
#line 2245 "Bezier.c"
	}
#line 293 "../src/Bezier.vala"
	if (_tmp31_) {
#line 294 "../src/Bezier.vala"
		if (from) {
#line 2251 "Bezier.c"
			BezierPoint* _tmp36_;
			gdouble* _tmp37_;
#line 294 "../src/Bezier.vala"
			_tmp36_ = self->priv->_from;
#line 294 "../src/Bezier.vala"
			_tmp37_ = isect;
#line 294 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp36_, right, *_tmp37_);
#line 2260 "Bezier.c"
		} else {
			BezierPoint* _tmp38_;
			gdouble* _tmp39_;
#line 294 "../src/Bezier.vala"
			_tmp38_ = self->priv->_to;
#line 294 "../src/Bezier.vala"
			_tmp39_ = isect;
#line 294 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp38_, right, *_tmp39_);
#line 2270 "Bezier.c"
		}
#line 295 "../src/Bezier.vala"
		_g_free0 (isect);
#line 295 "../src/Bezier.vala"
		return;
#line 2276 "Bezier.c"
	}
#line 298 "../src/Bezier.vala"
	if (from) {
#line 2280 "Bezier.c"
		BezierPoint* _tmp40_;
		GArray* _tmp41_;
		BezierPoint* _tmp42_;
		gdouble _tmp43_;
		gdouble _tmp44_;
		GArray* _tmp45_;
		BezierPoint* _tmp46_;
		gdouble _tmp47_;
		gdouble _tmp48_;
#line 299 "../src/Bezier.vala"
		_tmp40_ = self->priv->_from;
#line 299 "../src/Bezier.vala"
		_tmp41_ = self->priv->_points;
#line 299 "../src/Bezier.vala"
		_tmp42_ = g_array_index (_tmp41_, BezierPoint*, (guint) 0);
#line 299 "../src/Bezier.vala"
		_tmp43_ = bezier_point_get_x (_tmp42_);
#line 299 "../src/Bezier.vala"
		_tmp44_ = _tmp43_;
#line 299 "../src/Bezier.vala"
		_tmp45_ = self->priv->_points;
#line 299 "../src/Bezier.vala"
		_tmp46_ = g_array_index (_tmp45_, BezierPoint*, (guint) 0);
#line 299 "../src/Bezier.vala"
		_tmp47_ = bezier_point_get_y (_tmp46_);
#line 299 "../src/Bezier.vala"
		_tmp48_ = _tmp47_;
#line 299 "../src/Bezier.vala"
		bezier_point_set_coordinate (_tmp40_, _tmp44_, _tmp48_);
#line 2310 "Bezier.c"
	} else {
		BezierPoint* _tmp49_;
		GArray* _tmp50_;
		BezierPoint* _tmp51_;
		gdouble _tmp52_;
		gdouble _tmp53_;
		GArray* _tmp54_;
		BezierPoint* _tmp55_;
		gdouble _tmp56_;
		gdouble _tmp57_;
#line 301 "../src/Bezier.vala"
		_tmp49_ = self->priv->_to;
#line 301 "../src/Bezier.vala"
		_tmp50_ = self->priv->_points;
#line 301 "../src/Bezier.vala"
		_tmp51_ = g_array_index (_tmp50_, BezierPoint*, (guint) 2);
#line 301 "../src/Bezier.vala"
		_tmp52_ = bezier_point_get_x (_tmp51_);
#line 301 "../src/Bezier.vala"
		_tmp53_ = _tmp52_;
#line 301 "../src/Bezier.vala"
		_tmp54_ = self->priv->_points;
#line 301 "../src/Bezier.vala"
		_tmp55_ = g_array_index (_tmp54_, BezierPoint*, (guint) 2);
#line 301 "../src/Bezier.vala"
		_tmp56_ = bezier_point_get_y (_tmp55_);
#line 301 "../src/Bezier.vala"
		_tmp57_ = _tmp56_;
#line 301 "../src/Bezier.vala"
		bezier_point_set_coordinate (_tmp49_, _tmp53_, _tmp57_);
#line 2341 "Bezier.c"
	}
#line 266 "../src/Bezier.vala"
	_g_free0 (isect);
#line 2345 "Bezier.c"
}

static inline gpointer
bezier_point_get_instance_private (BezierPoint* self)
{
	return G_STRUCT_MEMBER_P (self, BezierPoint_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "../src/Bezier.vala"
	return self ? g_object_ref (self) : NULL;
#line 2359 "Bezier.c"
}

static BezierPoint*
bezier_point_construct (GType object_type,
                        DrawArea* da)
{
	BezierPoint* self = NULL;
	DrawArea* _tmp0_;
#line 46 "../src/Bezier.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 46 "../src/Bezier.vala"
	self = (BezierPoint*) g_type_create_instance (object_type);
#line 47 "../src/Bezier.vala"
	_tmp0_ = _g_object_ref0 (da);
#line 47 "../src/Bezier.vala"
	_g_object_unref0 (self->priv->_da);
#line 47 "../src/Bezier.vala"
	self->priv->_da = _tmp0_;
#line 46 "../src/Bezier.vala"
	return self;
#line 2380 "Bezier.c"
}

static BezierPoint*
bezier_point_new (DrawArea* da)
{
#line 46 "../src/Bezier.vala"
	return bezier_point_construct (BEZIER_TYPE_POINT, da);
#line 2388 "Bezier.c"
}

static BezierPoint*
bezier_point_construct_with_coordinate (GType object_type,
                                        DrawArea* da,
                                        gdouble a,
                                        gdouble b)
{
	BezierPoint* self = NULL;
	DrawArea* _tmp0_;
#line 49 "../src/Bezier.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 49 "../src/Bezier.vala"
	self = (BezierPoint*) g_type_create_instance (object_type);
#line 50 "../src/Bezier.vala"
	_tmp0_ = _g_object_ref0 (da);
#line 50 "../src/Bezier.vala"
	_g_object_unref0 (self->priv->_da);
#line 50 "../src/Bezier.vala"
	self->priv->_da = _tmp0_;
#line 51 "../src/Bezier.vala"
	bezier_point_set_x (self, a);
#line 52 "../src/Bezier.vala"
	bezier_point_set_y (self, b);
#line 49 "../src/Bezier.vala"
	return self;
#line 2415 "Bezier.c"
}

static BezierPoint*
bezier_point_new_with_coordinate (DrawArea* da,
                                  gdouble a,
                                  gdouble b)
{
#line 49 "../src/Bezier.vala"
	return bezier_point_construct_with_coordinate (BEZIER_TYPE_POINT, da, a, b);
#line 2425 "Bezier.c"
}

static void
bezier_point_set_coordinate (BezierPoint* self,
                             gdouble a,
                             gdouble b)
{
#line 54 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/Bezier.vala"
	bezier_point_set_x (self, a);
#line 56 "../src/Bezier.vala"
	bezier_point_set_y (self, b);
#line 2439 "Bezier.c"
}

static gdouble
bezier_point_get_x (BezierPoint* self)
{
	gdouble result;
	DrawArea* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 31 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 32 "../src/Bezier.vala"
	_tmp0_ = self->priv->_da;
#line 32 "../src/Bezier.vala"
	_tmp1_ = draw_area_get_origin_x (_tmp0_);
#line 32 "../src/Bezier.vala"
	_tmp2_ = _tmp1_;
#line 32 "../src/Bezier.vala"
	result = self->priv->_x + _tmp2_;
#line 32 "../src/Bezier.vala"
	return result;
#line 2461 "Bezier.c"
}

static void
bezier_point_set_x (BezierPoint* self,
                    gdouble value)
{
	DrawArea* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 34 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Bezier.vala"
	_tmp0_ = self->priv->_da;
#line 35 "../src/Bezier.vala"
	_tmp1_ = draw_area_get_origin_x (_tmp0_);
#line 35 "../src/Bezier.vala"
	_tmp2_ = _tmp1_;
#line 35 "../src/Bezier.vala"
	self->priv->_x = value - _tmp2_;
#line 2481 "Bezier.c"
}

static gdouble
bezier_point_get_y (BezierPoint* self)
{
	gdouble result;
	DrawArea* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 39 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 40 "../src/Bezier.vala"
	_tmp0_ = self->priv->_da;
#line 40 "../src/Bezier.vala"
	_tmp1_ = draw_area_get_origin_y (_tmp0_);
#line 40 "../src/Bezier.vala"
	_tmp2_ = _tmp1_;
#line 40 "../src/Bezier.vala"
	result = self->priv->_y + _tmp2_;
#line 40 "../src/Bezier.vala"
	return result;
#line 2503 "Bezier.c"
}

static void
bezier_point_set_y (BezierPoint* self,
                    gdouble value)
{
	DrawArea* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 42 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/Bezier.vala"
	_tmp0_ = self->priv->_da;
#line 43 "../src/Bezier.vala"
	_tmp1_ = draw_area_get_origin_y (_tmp0_);
#line 43 "../src/Bezier.vala"
	_tmp2_ = _tmp1_;
#line 43 "../src/Bezier.vala"
	self->priv->_y = value - _tmp2_;
#line 2523 "Bezier.c"
}

static void
bezier_value_point_init (GValue* value)
{
#line 26 "../src/Bezier.vala"
	value->data[0].v_pointer = NULL;
#line 2531 "Bezier.c"
}

static void
bezier_value_point_free_value (GValue* value)
{
#line 26 "../src/Bezier.vala"
	if (value->data[0].v_pointer) {
#line 26 "../src/Bezier.vala"
		bezier_point_unref (value->data[0].v_pointer);
#line 2541 "Bezier.c"
	}
}

static void
bezier_value_point_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 26 "../src/Bezier.vala"
	if (src_value->data[0].v_pointer) {
#line 26 "../src/Bezier.vala"
		dest_value->data[0].v_pointer = bezier_point_ref (src_value->data[0].v_pointer);
#line 2553 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2557 "Bezier.c"
	}
}

static gpointer
bezier_value_point_peek_pointer (const GValue* value)
{
#line 26 "../src/Bezier.vala"
	return value->data[0].v_pointer;
#line 2566 "Bezier.c"
}

static gchar*
bezier_value_point_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 26 "../src/Bezier.vala"
	if (collect_values[0].v_pointer) {
#line 2577 "Bezier.c"
		BezierPoint * object;
		object = collect_values[0].v_pointer;
#line 26 "../src/Bezier.vala"
		if (object->parent_instance.g_class == NULL) {
#line 26 "../src/Bezier.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2584 "Bezier.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 26 "../src/Bezier.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2588 "Bezier.c"
		}
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = bezier_point_ref (object);
#line 2592 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2596 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	return NULL;
#line 2600 "Bezier.c"
}

static gchar*
bezier_value_point_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	BezierPoint ** object_p;
	object_p = collect_values[0].v_pointer;
#line 26 "../src/Bezier.vala"
	if (!object_p) {
#line 26 "../src/Bezier.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2615 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	if (!value->data[0].v_pointer) {
#line 26 "../src/Bezier.vala"
		*object_p = NULL;
#line 2621 "Bezier.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 26 "../src/Bezier.vala"
		*object_p = value->data[0].v_pointer;
#line 2625 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		*object_p = bezier_point_ref (value->data[0].v_pointer);
#line 2629 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	return NULL;
#line 2633 "Bezier.c"
}

static GParamSpec*
bezier_param_spec_point (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	BezierParamSpecPoint* spec;
#line 26 "../src/Bezier.vala"
	g_return_val_if_fail (g_type_is_a (object_type, BEZIER_TYPE_POINT), NULL);
#line 26 "../src/Bezier.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 26 "../src/Bezier.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 26 "../src/Bezier.vala"
	return G_PARAM_SPEC (spec);
#line 2652 "Bezier.c"
}

static gpointer
bezier_value_get_point (const GValue* value)
{
#line 26 "../src/Bezier.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BEZIER_TYPE_POINT), NULL);
#line 26 "../src/Bezier.vala"
	return value->data[0].v_pointer;
#line 2662 "Bezier.c"
}

static void
bezier_value_set_point (GValue* value,
                        gpointer v_object)
{
	BezierPoint * old;
#line 26 "../src/Bezier.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BEZIER_TYPE_POINT));
#line 26 "../src/Bezier.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/Bezier.vala"
	if (v_object) {
#line 26 "../src/Bezier.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BEZIER_TYPE_POINT));
#line 26 "../src/Bezier.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = v_object;
#line 26 "../src/Bezier.vala"
		bezier_point_ref (value->data[0].v_pointer);
#line 2684 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2688 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	if (old) {
#line 26 "../src/Bezier.vala"
		bezier_point_unref (old);
#line 2694 "Bezier.c"
	}
}

static void
bezier_value_take_point (GValue* value,
                         gpointer v_object)
{
	BezierPoint * old;
#line 26 "../src/Bezier.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BEZIER_TYPE_POINT));
#line 26 "../src/Bezier.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/Bezier.vala"
	if (v_object) {
#line 26 "../src/Bezier.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BEZIER_TYPE_POINT));
#line 26 "../src/Bezier.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = v_object;
#line 2715 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2719 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	if (old) {
#line 26 "../src/Bezier.vala"
		bezier_point_unref (old);
#line 2725 "Bezier.c"
	}
}

static void
bezier_point_class_init (BezierPointClass * klass,
                         gpointer klass_data)
{
#line 26 "../src/Bezier.vala"
	bezier_point_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/Bezier.vala"
	((BezierPointClass *) klass)->finalize = bezier_point_finalize;
#line 26 "../src/Bezier.vala"
	g_type_class_adjust_private_offset (klass, &BezierPoint_private_offset);
#line 2739 "Bezier.c"
}

static void
bezier_point_instance_init (BezierPoint * self,
                            gpointer klass)
{
#line 26 "../src/Bezier.vala"
	self->priv = bezier_point_get_instance_private (self);
#line 28 "../src/Bezier.vala"
	self->priv->_x = (gdouble) 0;
#line 29 "../src/Bezier.vala"
	self->priv->_y = (gdouble) 0;
#line 26 "../src/Bezier.vala"
	self->ref_count = 1;
#line 2754 "Bezier.c"
}

static void
bezier_point_finalize (BezierPoint * obj)
{
	BezierPoint * self;
#line 26 "../src/Bezier.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BEZIER_TYPE_POINT, BezierPoint);
#line 26 "../src/Bezier.vala"
	g_signal_handlers_destroy (self);
#line 27 "../src/Bezier.vala"
	_g_object_unref0 (self->priv->_da);
#line 2767 "Bezier.c"
}

static GType
bezier_point_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { bezier_value_point_init, bezier_value_point_free_value, bezier_value_point_copy_value, bezier_value_point_peek_pointer, "p", bezier_value_point_collect_value, "p", bezier_value_point_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BezierPointClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bezier_point_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BezierPoint), 0, (GInstanceInitFunc) bezier_point_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType bezier_point_type_id;
	bezier_point_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BezierPoint", &g_define_type_info, &g_define_type_fundamental_info, 0);
	BezierPoint_private_offset = g_type_add_instance_private (bezier_point_type_id, sizeof (BezierPointPrivate));
	return bezier_point_type_id;
}

static GType
bezier_point_get_type (void)
{
	static volatile gsize bezier_point_type_id__once = 0;
	if (g_once_init_enter (&bezier_point_type_id__once)) {
		GType bezier_point_type_id;
		bezier_point_type_id = bezier_point_get_type_once ();
		g_once_init_leave (&bezier_point_type_id__once, bezier_point_type_id);
	}
	return bezier_point_type_id__once;
}

static gpointer
bezier_point_ref (gpointer instance)
{
	BezierPoint * self;
	self = instance;
#line 26 "../src/Bezier.vala"
	g_atomic_int_inc (&self->ref_count);
#line 26 "../src/Bezier.vala"
	return instance;
#line 2803 "Bezier.c"
}

static void
bezier_point_unref (gpointer instance)
{
	BezierPoint * self;
	self = instance;
#line 26 "../src/Bezier.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 26 "../src/Bezier.vala"
		BEZIER_POINT_GET_CLASS (self)->finalize (self);
#line 26 "../src/Bezier.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2817 "Bezier.c"
	}
}

static void
value_bezier_init (GValue* value)
{
#line 24 "../src/Bezier.vala"
	value->data[0].v_pointer = NULL;
#line 2826 "Bezier.c"
}

static void
value_bezier_free_value (GValue* value)
{
#line 24 "../src/Bezier.vala"
	if (value->data[0].v_pointer) {
#line 24 "../src/Bezier.vala"
		bezier_unref (value->data[0].v_pointer);
#line 2836 "Bezier.c"
	}
}

static void
value_bezier_copy_value (const GValue* src_value,
                         GValue* dest_value)
{
#line 24 "../src/Bezier.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "../src/Bezier.vala"
		dest_value->data[0].v_pointer = bezier_ref (src_value->data[0].v_pointer);
#line 2848 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2852 "Bezier.c"
	}
}

static gpointer
value_bezier_peek_pointer (const GValue* value)
{
#line 24 "../src/Bezier.vala"
	return value->data[0].v_pointer;
#line 2861 "Bezier.c"
}

static gchar*
value_bezier_collect_value (GValue* value,
                            guint n_collect_values,
                            GTypeCValue* collect_values,
                            guint collect_flags)
{
#line 24 "../src/Bezier.vala"
	if (collect_values[0].v_pointer) {
#line 2872 "Bezier.c"
		Bezier * object;
		object = collect_values[0].v_pointer;
#line 24 "../src/Bezier.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "../src/Bezier.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2879 "Bezier.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "../src/Bezier.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2883 "Bezier.c"
		}
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = bezier_ref (object);
#line 2887 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2891 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	return NULL;
#line 2895 "Bezier.c"
}

static gchar*
value_bezier_lcopy_value (const GValue* value,
                          guint n_collect_values,
                          GTypeCValue* collect_values,
                          guint collect_flags)
{
	Bezier ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "../src/Bezier.vala"
	if (!object_p) {
#line 24 "../src/Bezier.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2910 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	if (!value->data[0].v_pointer) {
#line 24 "../src/Bezier.vala"
		*object_p = NULL;
#line 2916 "Bezier.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "../src/Bezier.vala"
		*object_p = value->data[0].v_pointer;
#line 2920 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		*object_p = bezier_ref (value->data[0].v_pointer);
#line 2924 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	return NULL;
#line 2928 "Bezier.c"
}

GParamSpec*
param_spec_bezier (const gchar* name,
                   const gchar* nick,
                   const gchar* blurb,
                   GType object_type,
                   GParamFlags flags)
{
	ParamSpecBezier* spec;
#line 24 "../src/Bezier.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BEZIER), NULL);
#line 24 "../src/Bezier.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "../src/Bezier.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "../src/Bezier.vala"
	return G_PARAM_SPEC (spec);
#line 2947 "Bezier.c"
}

gpointer
value_get_bezier (const GValue* value)
{
#line 24 "../src/Bezier.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BEZIER), NULL);
#line 24 "../src/Bezier.vala"
	return value->data[0].v_pointer;
#line 2957 "Bezier.c"
}

void
value_set_bezier (GValue* value,
                  gpointer v_object)
{
	Bezier * old;
#line 24 "../src/Bezier.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BEZIER));
#line 24 "../src/Bezier.vala"
	old = value->data[0].v_pointer;
#line 24 "../src/Bezier.vala"
	if (v_object) {
#line 24 "../src/Bezier.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BEZIER));
#line 24 "../src/Bezier.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = v_object;
#line 24 "../src/Bezier.vala"
		bezier_ref (value->data[0].v_pointer);
#line 2979 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2983 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	if (old) {
#line 24 "../src/Bezier.vala"
		bezier_unref (old);
#line 2989 "Bezier.c"
	}
}

void
value_take_bezier (GValue* value,
                   gpointer v_object)
{
	Bezier * old;
#line 24 "../src/Bezier.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BEZIER));
#line 24 "../src/Bezier.vala"
	old = value->data[0].v_pointer;
#line 24 "../src/Bezier.vala"
	if (v_object) {
#line 24 "../src/Bezier.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BEZIER));
#line 24 "../src/Bezier.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = v_object;
#line 3010 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 3014 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	if (old) {
#line 24 "../src/Bezier.vala"
		bezier_unref (old);
#line 3020 "Bezier.c"
	}
}

static void
bezier_class_init (BezierClass * klass,
                   gpointer klass_data)
{
#line 24 "../src/Bezier.vala"
	bezier_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Bezier.vala"
	((BezierClass *) klass)->finalize = bezier_finalize;
#line 24 "../src/Bezier.vala"
	g_type_class_adjust_private_offset (klass, &Bezier_private_offset);
#line 3034 "Bezier.c"
}

static void
bezier_instance_init (Bezier * self,
                      gpointer klass)
{
	GArray* _tmp0_;
	GArray* _tmp1_;
#line 24 "../src/Bezier.vala"
	self->priv = bezier_get_instance_private (self);
#line 60 "../src/Bezier.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (BezierPoint*));
#line 60 "../src/Bezier.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_BezierPoint_free_function_content_of);
#line 60 "../src/Bezier.vala"
	self->priv->_points = _tmp0_;
#line 61 "../src/Bezier.vala"
	_tmp1_ = g_array_new (TRUE, TRUE, sizeof (BezierPoint*));
#line 61 "../src/Bezier.vala"
	g_array_set_clear_func (_tmp1_, (GDestroyNotify) _vala_BezierPoint_free_function_content_of);
#line 61 "../src/Bezier.vala"
	self->priv->_apoints = _tmp1_;
#line 24 "../src/Bezier.vala"
	self->ref_count = 1;
#line 3059 "Bezier.c"
}

static void
bezier_finalize (Bezier * obj)
{
	Bezier * self;
#line 24 "../src/Bezier.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BEZIER, Bezier);
#line 24 "../src/Bezier.vala"
	g_signal_handlers_destroy (self);
#line 60 "../src/Bezier.vala"
	_g_array_unref0 (self->priv->_points);
#line 61 "../src/Bezier.vala"
	_g_array_unref0 (self->priv->_apoints);
#line 62 "../src/Bezier.vala"
	_bezier_point_unref0 (self->priv->_from);
#line 63 "../src/Bezier.vala"
	_bezier_point_unref0 (self->priv->_to);
#line 3078 "Bezier.c"
}

static GType
bezier_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_bezier_init, value_bezier_free_value, value_bezier_copy_value, value_bezier_peek_pointer, "p", value_bezier_collect_value, "p", value_bezier_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BezierClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bezier_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bezier), 0, (GInstanceInitFunc) bezier_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType bezier_type_id;
	bezier_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Bezier", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Bezier_private_offset = g_type_add_instance_private (bezier_type_id, sizeof (BezierPrivate));
	return bezier_type_id;
}

GType
bezier_get_type (void)
{
	static volatile gsize bezier_type_id__once = 0;
	if (g_once_init_enter (&bezier_type_id__once)) {
		GType bezier_type_id;
		bezier_type_id = bezier_get_type_once ();
		g_once_init_leave (&bezier_type_id__once, bezier_type_id);
	}
	return bezier_type_id__once;
}

gpointer
bezier_ref (gpointer instance)
{
	Bezier * self;
	self = instance;
#line 24 "../src/Bezier.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "../src/Bezier.vala"
	return instance;
#line 3114 "Bezier.c"
}

void
bezier_unref (gpointer instance)
{
	Bezier * self;
	self = instance;
#line 24 "../src/Bezier.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "../src/Bezier.vala"
		BEZIER_GET_CLASS (self)->finalize (self);
#line 24 "../src/Bezier.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3128 "Bezier.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

