/* Clipboard.c generated by valac 0.56.17, the Vala compiler
 * generated from Clipboard.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <handy.h>
#include <gtksourceview/gtksource.h>
#include <gobject/gvaluecollector.h>

#define MINDER_CLIPBOARD_NODES_TARGET_NAME "x-application/minder-nodes"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MINDER_CLIPBOARD (minder_clipboard_get_type ())
#define MINDER_CLIPBOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MINDER_CLIPBOARD, MinderClipboard))
#define MINDER_CLIPBOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MINDER_CLIPBOARD, MinderClipboardClass))
#define IS_MINDER_CLIPBOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MINDER_CLIPBOARD))
#define IS_MINDER_CLIPBOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MINDER_CLIPBOARD))
#define MINDER_CLIPBOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MINDER_CLIPBOARD, MinderClipboardClass))

typedef struct _MinderClipboard MinderClipboard;
typedef struct _MinderClipboardClass MinderClipboardClass;
typedef struct _MinderClipboardPrivate MinderClipboardPrivate;
typedef enum  {
	MINDER_CLIPBOARD_TARGET_STRING,
	MINDER_CLIPBOARD_TARGET_IMAGE,
	MINDER_CLIPBOARD_TARGET_NODES
} MinderClipboardTarget;

#define MINDER_CLIPBOARD_TYPE_TARGET (minder_clipboard_target_get_type ())

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_CONNECTIONS (connections_get_type ())
#define CONNECTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONNECTIONS, Connections))
#define CONNECTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONNECTIONS, ConnectionsClass))
#define IS_CONNECTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONNECTIONS))
#define IS_CONNECTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONNECTIONS))
#define CONNECTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONNECTIONS, ConnectionsClass))

typedef struct _Connections Connections;
typedef struct _ConnectionsClass ConnectionsClass;

#define TYPE_EXPORT (export_get_type ())
#define EXPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORT, Export))
#define EXPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORT, ExportClass))
#define IS_EXPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORT))
#define IS_EXPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORT))
#define EXPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORT, ExportClass))

typedef struct _Export Export;
typedef struct _ExportClass ExportClass;

#define TYPE_EXPORT_TEXT (export_text_get_type ())
#define EXPORT_TEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORT_TEXT, ExportText))
#define EXPORT_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORT_TEXT, ExportTextClass))
#define IS_EXPORT_TEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORT_TEXT))
#define IS_EXPORT_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORT_TEXT))
#define EXPORT_TEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORT_TEXT, ExportTextClass))

typedef struct _ExportText ExportText;
typedef struct _ExportTextClass ExportTextClass;

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;

#define TYPE_EXPORTS (exports_get_type ())
#define EXPORTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORTS, Exports))
#define EXPORTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORTS, ExportsClass))
#define IS_EXPORTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORTS))
#define IS_EXPORTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORTS))
#define EXPORTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORTS, ExportsClass))

typedef struct _Exports Exports;
typedef struct _ExportsClass ExportsClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _export_unref0(var) ((var == NULL) ? NULL : (var = (export_unref (var), NULL)))

#define TYPE_NODE_IMAGE (node_image_get_type ())
#define NODE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_IMAGE, NodeImage))
#define NODE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE_IMAGE, NodeImageClass))
#define IS_NODE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_IMAGE))
#define IS_NODE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE_IMAGE))
#define NODE_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE_IMAGE, NodeImageClass))

typedef struct _NodeImage NodeImage;
typedef struct _NodeImageClass NodeImageClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _connections_unref0(var) ((var == NULL) ? NULL : (var = (connections_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;

#define TYPE_NOTE_VIEW (note_view_get_type ())
#define NOTE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTE_VIEW, NoteView))
#define NOTE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTE_VIEW, NoteViewClass))
#define IS_NOTE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTE_VIEW))
#define IS_NOTE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTE_VIEW))
#define NOTE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTE_VIEW, NoteViewClass))

typedef struct _NoteView NoteView;
typedef struct _NoteViewClass NoteViewClass;
typedef struct _Block5Data Block5Data;

#define TYPE_NODE_LINK (node_link_get_type ())
#define NODE_LINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_LINK, NodeLink))
#define NODE_LINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE_LINK, NodeLinkClass))
#define IS_NODE_LINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_LINK))
#define IS_NODE_LINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE_LINK))
#define NODE_LINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE_LINK, NodeLinkClass))

typedef struct _NodeLink NodeLink;
typedef struct _NodeLinkClass NodeLinkClass;
#define _node_link_unref0(var) ((var == NULL) ? NULL : (var = (node_link_unref (var), NULL)))
typedef struct _ParamSpecMinderClipboard ParamSpecMinderClipboard;

struct _MinderClipboard {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MinderClipboardPrivate * priv;
};

struct _MinderClipboardClass {
	GTypeClass parent_class;
	void (*finalize) (MinderClipboard *self);
};

struct _Block3Data {
	int _ref_count_;
	DrawArea* da;
	gboolean shift;
};

struct _Block4Data {
	int _ref_count_;
	DrawArea* da;
};

struct _Block5Data {
	int _ref_count_;
	NoteView* note;
};

struct _ParamSpecMinderClipboard {
	GParamSpec parent_instance;
};

static gpointer minder_clipboard_parent_class = NULL;
static GdkAtom minder_clipboard_NODES_ATOM;
static GdkAtom minder_clipboard_NODES_ATOM = 0U;
static DrawArea* minder_clipboard_da;
static DrawArea* minder_clipboard_da = NULL;
static GArray* minder_clipboard_nodes;
static GArray* minder_clipboard_nodes = NULL;
static Connections* minder_clipboard_conns;
static Connections* minder_clipboard_conns = NULL;
static gchar* minder_clipboard_text;
static gchar* minder_clipboard_text = NULL;
static GdkPixbuf* minder_clipboard_image;
static GdkPixbuf* minder_clipboard_image = NULL;
static gboolean minder_clipboard_set_internally;
static gboolean minder_clipboard_set_internally = FALSE;

VALA_EXTERN gpointer minder_clipboard_ref (gpointer instance);
VALA_EXTERN void minder_clipboard_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_minder_clipboard (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void value_set_minder_clipboard (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void value_take_minder_clipboard (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer value_get_minder_clipboard (const GValue* value);
VALA_EXTERN GType minder_clipboard_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MinderClipboard, minder_clipboard_unref)
static GType minder_clipboard_target_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN GType draw_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
VALA_EXTERN GType node_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
VALA_EXTERN gpointer connections_ref (gpointer instance);
VALA_EXTERN void connections_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_connections (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_connections (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_connections (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_connections (const GValue* value);
VALA_EXTERN GType connections_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Connections, connections_unref)
VALA_EXTERN void minder_clipboard_set_with_data (GtkClipboard* clipboard,
                                     GtkSelectionData* selection_data,
                                     guint info,
                                     void* user_data_or_owner);
VALA_EXTERN gpointer export_ref (gpointer instance);
VALA_EXTERN void export_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_export (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
VALA_EXTERN void value_set_export (GValue* value,
                       gpointer v_object);
VALA_EXTERN void value_take_export (GValue* value,
                        gpointer v_object);
VALA_EXTERN gpointer value_get_export (const GValue* value);
VALA_EXTERN GType export_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Export, export_unref)
VALA_EXTERN GType export_text_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ExportText, export_unref)
VALA_EXTERN GType main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
VALA_EXTERN MainWindow* draw_area_get_win (DrawArea* self);
VALA_EXTERN gpointer exports_ref (gpointer instance);
VALA_EXTERN void exports_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_exports (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
VALA_EXTERN void value_set_exports (GValue* value,
                        gpointer v_object);
VALA_EXTERN void value_take_exports (GValue* value,
                         gpointer v_object);
VALA_EXTERN gpointer value_get_exports (const GValue* value);
VALA_EXTERN GType exports_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Exports, exports_unref)
VALA_EXTERN Exports* main_window_get_exports (MainWindow* self);
VALA_EXTERN Export* exports_get_by_name (Exports* self,
                             const gchar* name);
VALA_EXTERN gchar* export_text_export_node (ExportText* self,
                                DrawArea* da,
                                Node* node,
                                const gchar* prefix);
VALA_EXTERN gpointer node_image_ref (gpointer instance);
VALA_EXTERN void node_image_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_node_image (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_node_image (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_node_image (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_node_image (const GValue* value);
VALA_EXTERN GType node_image_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NodeImage, node_image_unref)
VALA_EXTERN NodeImage* node_get_image (Node* self);
VALA_EXTERN GdkPixbuf* node_image_get_pixbuf (NodeImage* self);
VALA_EXTERN gchar* draw_area_serialize_for_copy (DrawArea* self,
                                     GArray* nodes,
                                     Connections* conns);
VALA_EXTERN void minder_clipboard_clear_data (GtkClipboard* clipboard,
                                  void* user_data_or_owner);
VALA_EXTERN void minder_clipboard_copy_text (const gchar* txt);
static void _minder_clipboard_set_with_data_gtk_clipboard_get_func (GtkClipboard* clipboard,
                                                             GtkSelectionData* selection_data,
                                                             guint info,
                                                             void* user_data_or_owner);
static void _minder_clipboard_clear_data_gtk_clipboard_clear_func (GtkClipboard* clipboard,
                                                            void* user_data_or_owner);
VALA_EXTERN void minder_clipboard_copy_image (GdkPixbuf* img);
VALA_EXTERN void minder_clipboard_copy_nodes (DrawArea* d);
VALA_EXTERN void draw_area_get_nodes_for_clipboard (DrawArea* self,
                                        GArray** nodes,
                                        Connections** conns);
VALA_EXTERN gboolean minder_clipboard_node_pasteable (void);
VALA_EXTERN void minder_clipboard_paste (DrawArea* da,
                             gboolean shift);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
VALA_EXTERN gboolean draw_area_is_node_editable (DrawArea* self);
VALA_EXTERN gboolean draw_area_is_connection_editable (DrawArea* self);
static GdkAtom* _gdk_atom_dup (GdkAtom* self);
static void ___lambda49_ (Block3Data* _data3_,
                   GtkClipboard* c,
                   GtkSelectionData* raw_data);
VALA_EXTERN void draw_area_paste_nodes (DrawArea* self,
                            const gchar* text,
                            gboolean shift);
static void ____lambda49__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                                GtkSelectionData* selection_data,
                                                gpointer self);
static void ____lambda50_ (Block3Data* _data3_,
                    GtkClipboard* c,
                    GtkSelectionData* raw_data);
VALA_EXTERN void draw_area_paste_image (DrawArea* self,
                            GdkPixbuf* image,
                            gboolean shift);
static void _____lambda50__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                                 GtkSelectionData* selection_data,
                                                 gpointer self);
static void _____lambda51_ (Block3Data* _data3_,
                     GtkClipboard* c,
                     GtkSelectionData* raw_data);
VALA_EXTERN void draw_area_paste_text (DrawArea* self,
                           const gchar* text,
                           gboolean shift);
static void ______lambda51__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                                  GtkSelectionData* selection_data,
                                                  gpointer self);
VALA_EXTERN void minder_clipboard_paste_node_link (DrawArea* da);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _____lambda52_ (Block4Data* _data4_,
                     GtkClipboard* c,
                     GtkSelectionData* raw_data);
VALA_EXTERN void draw_area_paste_node_link (DrawArea* self,
                                const gchar* text);
static void ______lambda52__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                                  GtkSelectionData* selection_data,
                                                  gpointer self);
VALA_EXTERN GType note_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NoteView, g_object_unref)
VALA_EXTERN void minder_clipboard_paste_into_note (NoteView* note);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda53_ (Block5Data* _data5_,
                   GtkClipboard* c,
                   GtkSelectionData* raw_data);
VALA_EXTERN gpointer node_link_ref (gpointer instance);
VALA_EXTERN void node_link_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_node_link (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void value_set_node_link (GValue* value,
                          gpointer v_object);
VALA_EXTERN void value_take_node_link (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer value_get_node_link (const GValue* value);
VALA_EXTERN GType node_link_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NodeLink, node_link_unref)
VALA_EXTERN NodeLink* draw_area_deserialize_for_node_link (const gchar* str);
VALA_EXTERN void note_view_paste_node_link (NoteView* self,
                                NodeLink* link);
static void ____lambda53__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                                GtkSelectionData* selection_data,
                                                gpointer self);
static void ____lambda54_ (Block5Data* _data5_,
                    GtkClipboard* c,
                    GtkSelectionData* raw_data);
VALA_EXTERN void note_view_paste_text (NoteView* self,
                           const gchar* str);
static void _____lambda54__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                                 GtkSelectionData* selection_data,
                                                 gpointer self);
VALA_EXTERN MinderClipboard* minder_clipboard_new (void);
VALA_EXTERN MinderClipboard* minder_clipboard_construct (GType object_type);
static void minder_clipboard_finalize (MinderClipboard * obj);
static GType minder_clipboard_get_type_once (void);

static const GtkTargetEntry MINDER_CLIPBOARD_text_target_list[3] = {{"UTF8_STRING", (guint) 0, (guint) MINDER_CLIPBOARD_TARGET_STRING}, {"text/plain", (guint) 0, (guint) MINDER_CLIPBOARD_TARGET_STRING}, {"STRING", (guint) 0, (guint) MINDER_CLIPBOARD_TARGET_STRING}};
static const GtkTargetEntry MINDER_CLIPBOARD_image_target_list[1] = {{"image/png", (guint) 0, (guint) MINDER_CLIPBOARD_TARGET_IMAGE}};
static const GtkTargetEntry MINDER_CLIPBOARD_node_target_list[5] = {{"UTF8_STRING", (guint) 0, (guint) MINDER_CLIPBOARD_TARGET_STRING}, {"text/plain", (guint) 0, (guint) MINDER_CLIPBOARD_TARGET_STRING}, {"STRING", (guint) 0, (guint) MINDER_CLIPBOARD_TARGET_STRING}, {"image/png", (guint) 0, (guint) MINDER_CLIPBOARD_TARGET_IMAGE}, {MINDER_CLIPBOARD_NODES_TARGET_NAME, (guint) 0, (guint) MINDER_CLIPBOARD_TARGET_NODES}};

static GType
minder_clipboard_target_get_type_once (void)
{
	static const GEnumValue values[] = {{MINDER_CLIPBOARD_TARGET_STRING, "MINDER_CLIPBOARD_TARGET_STRING", "string"}, {MINDER_CLIPBOARD_TARGET_IMAGE, "MINDER_CLIPBOARD_TARGET_IMAGE", "image"}, {MINDER_CLIPBOARD_TARGET_NODES, "MINDER_CLIPBOARD_TARGET_NODES", "nodes"}, {0, NULL, NULL}};
	GType minder_clipboard_target_type_id;
	minder_clipboard_target_type_id = g_enum_register_static ("MinderClipboardTarget", values);
	return minder_clipboard_target_type_id;
}

static GType
minder_clipboard_target_get_type (void)
{
	static volatile gsize minder_clipboard_target_type_id__once = 0;
	if (g_once_init_enter (&minder_clipboard_target_type_id__once)) {
		GType minder_clipboard_target_type_id;
		minder_clipboard_target_type_id = minder_clipboard_target_get_type_once ();
		g_once_init_leave (&minder_clipboard_target_type_id__once, minder_clipboard_target_type_id);
	}
	return minder_clipboard_target_type_id__once;
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 487 "Clipboard.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 493 "Clipboard.c"
}

void
minder_clipboard_set_with_data (GtkClipboard* clipboard,
                                GtkSelectionData* selection_data,
                                guint info,
                                void* user_data_or_owner)
{
#line 63 "../src/Clipboard.vala"
	g_return_if_fail (clipboard != NULL);
#line 63 "../src/Clipboard.vala"
	g_return_if_fail (selection_data != NULL);
#line 64 "../src/Clipboard.vala"
	switch (info) {
#line 64 "../src/Clipboard.vala"
		case MINDER_CLIPBOARD_TARGET_STRING:
#line 510 "Clipboard.c"
		{
			const gchar* _tmp0_;
#line 66 "../src/Clipboard.vala"
			_tmp0_ = minder_clipboard_text;
#line 66 "../src/Clipboard.vala"
			if (_tmp0_ != NULL) {
#line 517 "Clipboard.c"
				const gchar* _tmp1_;
#line 67 "../src/Clipboard.vala"
				_tmp1_ = minder_clipboard_text;
#line 67 "../src/Clipboard.vala"
				gtk_selection_data_set_text (selection_data, _tmp1_, -1);
#line 523 "Clipboard.c"
			} else {
				gboolean _tmp2_ = FALSE;
				GArray* _tmp3_;
#line 68 "../src/Clipboard.vala"
				_tmp3_ = minder_clipboard_nodes;
#line 68 "../src/Clipboard.vala"
				if (_tmp3_ != NULL) {
#line 531 "Clipboard.c"
					GArray* _tmp4_;
#line 68 "../src/Clipboard.vala"
					_tmp4_ = minder_clipboard_nodes;
#line 68 "../src/Clipboard.vala"
					_tmp2_ = _tmp4_->len == ((guint) 1);
#line 537 "Clipboard.c"
				} else {
#line 68 "../src/Clipboard.vala"
					_tmp2_ = FALSE;
#line 541 "Clipboard.c"
				}
#line 68 "../src/Clipboard.vala"
				if (_tmp2_) {
#line 545 "Clipboard.c"
					gchar* str = NULL;
					gchar* _tmp5_;
					ExportText* export = NULL;
					DrawArea* _tmp6_;
					MainWindow* _tmp7_;
					MainWindow* _tmp8_;
					Exports* _tmp9_;
					Exports* _tmp10_;
					Export* _tmp11_;
					const gchar* _tmp23_;
#line 69 "../src/Clipboard.vala"
					_tmp5_ = g_strdup ("");
#line 69 "../src/Clipboard.vala"
					str = _tmp5_;
#line 70 "../src/Clipboard.vala"
					_tmp6_ = minder_clipboard_da;
#line 70 "../src/Clipboard.vala"
					_tmp7_ = draw_area_get_win (_tmp6_);
#line 70 "../src/Clipboard.vala"
					_tmp8_ = _tmp7_;
#line 70 "../src/Clipboard.vala"
					_tmp9_ = main_window_get_exports (_tmp8_);
#line 70 "../src/Clipboard.vala"
					_tmp10_ = _tmp9_;
#line 70 "../src/Clipboard.vala"
					_tmp11_ = exports_get_by_name (_tmp10_, "text");
#line 70 "../src/Clipboard.vala"
					export = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_EXPORT_TEXT, ExportText);
#line 574 "Clipboard.c"
					{
						gint i = 0;
#line 71 "../src/Clipboard.vala"
						i = 0;
#line 579 "Clipboard.c"
						{
							gboolean _tmp12_ = FALSE;
#line 71 "../src/Clipboard.vala"
							_tmp12_ = TRUE;
#line 71 "../src/Clipboard.vala"
							while (TRUE) {
#line 586 "Clipboard.c"
								GArray* _tmp14_;
								const gchar* _tmp15_;
								ExportText* _tmp16_;
								DrawArea* _tmp17_;
								GArray* _tmp18_;
								Node* _tmp19_;
								gchar* _tmp20_;
								gchar* _tmp21_;
								gchar* _tmp22_;
#line 71 "../src/Clipboard.vala"
								if (!_tmp12_) {
#line 598 "Clipboard.c"
									gint _tmp13_;
#line 71 "../src/Clipboard.vala"
									_tmp13_ = i;
#line 71 "../src/Clipboard.vala"
									i = _tmp13_ + 1;
#line 604 "Clipboard.c"
								}
#line 71 "../src/Clipboard.vala"
								_tmp12_ = FALSE;
#line 71 "../src/Clipboard.vala"
								_tmp14_ = minder_clipboard_nodes;
#line 71 "../src/Clipboard.vala"
								if (!(((guint) i) < _tmp14_->len)) {
#line 71 "../src/Clipboard.vala"
									break;
#line 614 "Clipboard.c"
								}
#line 72 "../src/Clipboard.vala"
								_tmp15_ = str;
#line 72 "../src/Clipboard.vala"
								_tmp16_ = export;
#line 72 "../src/Clipboard.vala"
								_tmp17_ = minder_clipboard_da;
#line 72 "../src/Clipboard.vala"
								_tmp18_ = minder_clipboard_nodes;
#line 72 "../src/Clipboard.vala"
								_tmp19_ = g_array_index (_tmp18_, Node*, (guint) i);
#line 72 "../src/Clipboard.vala"
								_tmp20_ = export_text_export_node (_tmp16_, _tmp17_, _tmp19_, "");
#line 72 "../src/Clipboard.vala"
								_tmp21_ = _tmp20_;
#line 72 "../src/Clipboard.vala"
								_tmp22_ = g_strconcat (_tmp15_, _tmp21_, NULL);
#line 72 "../src/Clipboard.vala"
								_g_free0 (str);
#line 72 "../src/Clipboard.vala"
								str = _tmp22_;
#line 72 "../src/Clipboard.vala"
								_g_free0 (_tmp21_);
#line 638 "Clipboard.c"
							}
						}
					}
#line 74 "../src/Clipboard.vala"
					_tmp23_ = str;
#line 74 "../src/Clipboard.vala"
					gtk_selection_data_set_text (selection_data, _tmp23_, -1);
#line 68 "../src/Clipboard.vala"
					_export_unref0 (export);
#line 68 "../src/Clipboard.vala"
					_g_free0 (str);
#line 650 "Clipboard.c"
				}
			}
#line 76 "../src/Clipboard.vala"
			break;
#line 655 "Clipboard.c"
		}
#line 64 "../src/Clipboard.vala"
		case MINDER_CLIPBOARD_TARGET_IMAGE:
#line 659 "Clipboard.c"
		{
			GdkPixbuf* _tmp24_;
#line 78 "../src/Clipboard.vala"
			_tmp24_ = minder_clipboard_image;
#line 78 "../src/Clipboard.vala"
			if (_tmp24_ != NULL) {
#line 666 "Clipboard.c"
				GdkPixbuf* _tmp25_;
#line 79 "../src/Clipboard.vala"
				_tmp25_ = minder_clipboard_image;
#line 79 "../src/Clipboard.vala"
				gtk_selection_data_set_pixbuf (selection_data, _tmp25_);
#line 672 "Clipboard.c"
			} else {
				gboolean _tmp26_ = FALSE;
				gboolean _tmp27_ = FALSE;
				GArray* _tmp28_;
#line 80 "../src/Clipboard.vala"
				_tmp28_ = minder_clipboard_nodes;
#line 80 "../src/Clipboard.vala"
				if (_tmp28_ != NULL) {
#line 681 "Clipboard.c"
					GArray* _tmp29_;
#line 80 "../src/Clipboard.vala"
					_tmp29_ = minder_clipboard_nodes;
#line 80 "../src/Clipboard.vala"
					_tmp27_ = _tmp29_->len == ((guint) 1);
#line 687 "Clipboard.c"
				} else {
#line 80 "../src/Clipboard.vala"
					_tmp27_ = FALSE;
#line 691 "Clipboard.c"
				}
#line 80 "../src/Clipboard.vala"
				if (_tmp27_) {
#line 695 "Clipboard.c"
					GArray* _tmp30_;
					Node* _tmp31_;
					NodeImage* _tmp32_;
					NodeImage* _tmp33_;
#line 80 "../src/Clipboard.vala"
					_tmp30_ = minder_clipboard_nodes;
#line 80 "../src/Clipboard.vala"
					_tmp31_ = g_array_index (_tmp30_, Node*, (guint) 0);
#line 80 "../src/Clipboard.vala"
					_tmp32_ = node_get_image (_tmp31_);
#line 80 "../src/Clipboard.vala"
					_tmp33_ = _tmp32_;
#line 80 "../src/Clipboard.vala"
					_tmp26_ = _tmp33_ != NULL;
#line 710 "Clipboard.c"
				} else {
#line 80 "../src/Clipboard.vala"
					_tmp26_ = FALSE;
#line 714 "Clipboard.c"
				}
#line 80 "../src/Clipboard.vala"
				if (_tmp26_) {
#line 718 "Clipboard.c"
					GArray* _tmp34_;
					Node* _tmp35_;
					NodeImage* _tmp36_;
					NodeImage* _tmp37_;
					GdkPixbuf* _tmp38_;
					GdkPixbuf* _tmp39_;
					GdkPixbuf* _tmp40_;
					GdkPixbuf* _tmp41_;
#line 81 "../src/Clipboard.vala"
					_tmp34_ = minder_clipboard_nodes;
#line 81 "../src/Clipboard.vala"
					_tmp35_ = g_array_index (_tmp34_, Node*, (guint) 0);
#line 81 "../src/Clipboard.vala"
					_tmp36_ = node_get_image (_tmp35_);
#line 81 "../src/Clipboard.vala"
					_tmp37_ = _tmp36_;
#line 81 "../src/Clipboard.vala"
					_tmp38_ = node_image_get_pixbuf (_tmp37_);
#line 81 "../src/Clipboard.vala"
					_tmp39_ = _tmp38_;
#line 81 "../src/Clipboard.vala"
					_tmp40_ = gdk_pixbuf_copy (_tmp39_);
#line 81 "../src/Clipboard.vala"
					_tmp41_ = _tmp40_;
#line 81 "../src/Clipboard.vala"
					gtk_selection_data_set_pixbuf (selection_data, _tmp41_);
#line 81 "../src/Clipboard.vala"
					_g_object_unref0 (_tmp41_);
#line 81 "../src/Clipboard.vala"
					_g_object_unref0 (_tmp39_);
#line 749 "Clipboard.c"
				}
			}
#line 83 "../src/Clipboard.vala"
			break;
#line 754 "Clipboard.c"
		}
#line 64 "../src/Clipboard.vala"
		case MINDER_CLIPBOARD_TARGET_NODES:
#line 758 "Clipboard.c"
		{
			gboolean _tmp42_ = FALSE;
			GArray* _tmp43_;
#line 85 "../src/Clipboard.vala"
			_tmp43_ = minder_clipboard_nodes;
#line 85 "../src/Clipboard.vala"
			if (_tmp43_ != NULL) {
#line 766 "Clipboard.c"
				GArray* _tmp44_;
#line 85 "../src/Clipboard.vala"
				_tmp44_ = minder_clipboard_nodes;
#line 85 "../src/Clipboard.vala"
				_tmp42_ = _tmp44_->len > ((guint) 0);
#line 772 "Clipboard.c"
			} else {
#line 85 "../src/Clipboard.vala"
				_tmp42_ = FALSE;
#line 776 "Clipboard.c"
			}
#line 85 "../src/Clipboard.vala"
			if (_tmp42_) {
#line 780 "Clipboard.c"
				gchar* text = NULL;
				DrawArea* _tmp45_;
				GArray* _tmp46_;
				Connections* _tmp47_;
				gchar* _tmp48_;
				const gchar* _tmp49_;
				guint8* _tmp50_;
				gint _tmp50__length1;
				gint _tmp51_ = 0;
				guint8* _tmp52_;
				gint _tmp52__length1;
#line 86 "../src/Clipboard.vala"
				_tmp45_ = minder_clipboard_da;
#line 86 "../src/Clipboard.vala"
				_tmp46_ = minder_clipboard_nodes;
#line 86 "../src/Clipboard.vala"
				_tmp47_ = minder_clipboard_conns;
#line 86 "../src/Clipboard.vala"
				_tmp48_ = draw_area_serialize_for_copy (_tmp45_, _tmp46_, _tmp47_);
#line 86 "../src/Clipboard.vala"
				text = _tmp48_;
#line 87 "../src/Clipboard.vala"
				_tmp49_ = text;
#line 87 "../src/Clipboard.vala"
				_tmp50_ = string_get_data (_tmp49_, &_tmp51_);
#line 87 "../src/Clipboard.vala"
				_tmp50__length1 = _tmp51_;
#line 87 "../src/Clipboard.vala"
				_tmp52_ = _tmp50_;
#line 87 "../src/Clipboard.vala"
				_tmp52__length1 = _tmp50__length1;
#line 87 "../src/Clipboard.vala"
				gtk_selection_data_set (selection_data, minder_clipboard_NODES_ATOM, 0, _tmp52_, (gint) _tmp52__length1);
#line 85 "../src/Clipboard.vala"
				_g_free0 (text);
#line 816 "Clipboard.c"
			}
#line 89 "../src/Clipboard.vala"
			break;
#line 820 "Clipboard.c"
		}
		default:
#line 64 "../src/Clipboard.vala"
		break;
#line 825 "Clipboard.c"
	}
}

void
minder_clipboard_clear_data (GtkClipboard* clipboard,
                             void* user_data_or_owner)
{
#line 94 "../src/Clipboard.vala"
	g_return_if_fail (clipboard != NULL);
#line 95 "../src/Clipboard.vala"
	if (!minder_clipboard_set_internally) {
#line 96 "../src/Clipboard.vala"
		_g_object_unref0 (minder_clipboard_da);
#line 96 "../src/Clipboard.vala"
		minder_clipboard_da = NULL;
#line 97 "../src/Clipboard.vala"
		_g_array_unref0 (minder_clipboard_nodes);
#line 97 "../src/Clipboard.vala"
		minder_clipboard_nodes = NULL;
#line 98 "../src/Clipboard.vala"
		_connections_unref0 (minder_clipboard_conns);
#line 98 "../src/Clipboard.vala"
		minder_clipboard_conns = NULL;
#line 99 "../src/Clipboard.vala"
		_g_free0 (minder_clipboard_text);
#line 99 "../src/Clipboard.vala"
		minder_clipboard_text = NULL;
#line 100 "../src/Clipboard.vala"
		_g_object_unref0 (minder_clipboard_image);
#line 100 "../src/Clipboard.vala"
		minder_clipboard_image = NULL;
#line 857 "Clipboard.c"
	}
#line 102 "../src/Clipboard.vala"
	minder_clipboard_set_internally = FALSE;
#line 861 "Clipboard.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 113 "../src/Clipboard.vala"
	return self ? g_object_ref (self) : NULL;
#line 869 "Clipboard.c"
}

static void
_minder_clipboard_set_with_data_gtk_clipboard_get_func (GtkClipboard* clipboard,
                                                        GtkSelectionData* selection_data,
                                                        guint info,
                                                        void* user_data_or_owner)
{
#line 114 "../src/Clipboard.vala"
	minder_clipboard_set_with_data (clipboard, selection_data, info, user_data_or_owner);
#line 880 "Clipboard.c"
}

static void
_minder_clipboard_clear_data_gtk_clipboard_clear_func (GtkClipboard* clipboard,
                                                       void* user_data_or_owner)
{
#line 114 "../src/Clipboard.vala"
	minder_clipboard_clear_data (clipboard, user_data_or_owner);
#line 889 "Clipboard.c"
}

void
minder_clipboard_copy_text (const gchar* txt)
{
	gchar* _tmp0_;
	GtkClipboard* clipboard = NULL;
	GdkDisplay* _tmp1_;
	GtkClipboard* _tmp2_;
	GtkClipboard* _tmp3_;
#line 106 "../src/Clipboard.vala"
	g_return_if_fail (txt != NULL);
#line 109 "../src/Clipboard.vala"
	_tmp0_ = g_strdup (txt);
#line 109 "../src/Clipboard.vala"
	_g_free0 (minder_clipboard_text);
#line 109 "../src/Clipboard.vala"
	minder_clipboard_text = _tmp0_;
#line 110 "../src/Clipboard.vala"
	minder_clipboard_set_internally = TRUE;
#line 113 "../src/Clipboard.vala"
	_tmp1_ = gdk_display_get_default ();
#line 113 "../src/Clipboard.vala"
	_tmp2_ = gtk_clipboard_get_default (_tmp1_);
#line 113 "../src/Clipboard.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 113 "../src/Clipboard.vala"
	clipboard = _tmp3_;
#line 114 "../src/Clipboard.vala"
	gtk_clipboard_set_with_data (clipboard, MINDER_CLIPBOARD_text_target_list, (guint) G_N_ELEMENTS (MINDER_CLIPBOARD_text_target_list), _minder_clipboard_set_with_data_gtk_clipboard_get_func, _minder_clipboard_clear_data_gtk_clipboard_clear_func, NULL);
#line 106 "../src/Clipboard.vala"
	_g_object_unref0 (clipboard);
#line 922 "Clipboard.c"
}

void
minder_clipboard_copy_image (GdkPixbuf* img)
{
	GdkPixbuf* _tmp0_;
	GtkClipboard* clipboard = NULL;
	GdkDisplay* _tmp1_;
	GtkClipboard* _tmp2_;
	GtkClipboard* _tmp3_;
#line 118 "../src/Clipboard.vala"
	g_return_if_fail (img != NULL);
#line 121 "../src/Clipboard.vala"
	_tmp0_ = _g_object_ref0 (img);
#line 121 "../src/Clipboard.vala"
	_g_object_unref0 (minder_clipboard_image);
#line 121 "../src/Clipboard.vala"
	minder_clipboard_image = _tmp0_;
#line 122 "../src/Clipboard.vala"
	minder_clipboard_set_internally = TRUE;
#line 125 "../src/Clipboard.vala"
	_tmp1_ = gdk_display_get_default ();
#line 125 "../src/Clipboard.vala"
	_tmp2_ = gtk_clipboard_get_default (_tmp1_);
#line 125 "../src/Clipboard.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 125 "../src/Clipboard.vala"
	clipboard = _tmp3_;
#line 126 "../src/Clipboard.vala"
	gtk_clipboard_set_with_data (clipboard, MINDER_CLIPBOARD_image_target_list, (guint) G_N_ELEMENTS (MINDER_CLIPBOARD_image_target_list), _minder_clipboard_set_with_data_gtk_clipboard_get_func, _minder_clipboard_clear_data_gtk_clipboard_clear_func, NULL);
#line 118 "../src/Clipboard.vala"
	_g_object_unref0 (clipboard);
#line 955 "Clipboard.c"
}

void
minder_clipboard_copy_nodes (DrawArea* d)
{
	DrawArea* _tmp0_;
	DrawArea* _tmp1_;
	GArray* _tmp2_ = NULL;
	Connections* _tmp3_ = NULL;
	GtkClipboard* clipboard = NULL;
	GdkDisplay* _tmp4_;
	GtkClipboard* _tmp5_;
	GtkClipboard* _tmp6_;
#line 131 "../src/Clipboard.vala"
	g_return_if_fail (d != NULL);
#line 134 "../src/Clipboard.vala"
	_tmp0_ = _g_object_ref0 (d);
#line 134 "../src/Clipboard.vala"
	_g_object_unref0 (minder_clipboard_da);
#line 134 "../src/Clipboard.vala"
	minder_clipboard_da = _tmp0_;
#line 135 "../src/Clipboard.vala"
	_tmp1_ = minder_clipboard_da;
#line 135 "../src/Clipboard.vala"
	draw_area_get_nodes_for_clipboard (_tmp1_, &_tmp2_, &_tmp3_);
#line 135 "../src/Clipboard.vala"
	_g_array_unref0 (minder_clipboard_nodes);
#line 135 "../src/Clipboard.vala"
	minder_clipboard_nodes = _tmp2_;
#line 135 "../src/Clipboard.vala"
	_connections_unref0 (minder_clipboard_conns);
#line 135 "../src/Clipboard.vala"
	minder_clipboard_conns = _tmp3_;
#line 137 "../src/Clipboard.vala"
	minder_clipboard_set_internally = TRUE;
#line 140 "../src/Clipboard.vala"
	_tmp4_ = gdk_display_get_default ();
#line 140 "../src/Clipboard.vala"
	_tmp5_ = gtk_clipboard_get_default (_tmp4_);
#line 140 "../src/Clipboard.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 140 "../src/Clipboard.vala"
	clipboard = _tmp6_;
#line 141 "../src/Clipboard.vala"
	gtk_clipboard_set_with_data (clipboard, MINDER_CLIPBOARD_node_target_list, (guint) G_N_ELEMENTS (MINDER_CLIPBOARD_node_target_list), _minder_clipboard_set_with_data_gtk_clipboard_get_func, _minder_clipboard_clear_data_gtk_clipboard_clear_func, NULL);
#line 131 "../src/Clipboard.vala"
	_g_object_unref0 (clipboard);
#line 1003 "Clipboard.c"
}

gboolean
minder_clipboard_node_pasteable (void)
{
	GtkClipboard* clipboard = NULL;
	GdkDisplay* _tmp0_;
	GtkClipboard* _tmp1_;
	GtkClipboard* _tmp2_;
	GdkAtom* targets = NULL;
	gint targets_length1 = 0;
	gint _targets_size_ = 0;
	GtkClipboard* _tmp3_;
	GdkAtom* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	GdkAtom* _tmp6_;
	gint _tmp6__length1;
	gboolean result;
#line 148 "../src/Clipboard.vala"
	_tmp0_ = gdk_display_get_default ();
#line 148 "../src/Clipboard.vala"
	_tmp1_ = gtk_clipboard_get_default (_tmp0_);
#line 148 "../src/Clipboard.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 148 "../src/Clipboard.vala"
	clipboard = _tmp2_;
#line 151 "../src/Clipboard.vala"
	_tmp3_ = clipboard;
#line 151 "../src/Clipboard.vala"
	gtk_clipboard_wait_for_targets (_tmp3_, &_tmp4_, &_tmp5_);
#line 151 "../src/Clipboard.vala"
	targets = (g_free (targets), NULL);
#line 151 "../src/Clipboard.vala"
	targets = _tmp4_;
#line 151 "../src/Clipboard.vala"
	targets_length1 = _tmp5_;
#line 151 "../src/Clipboard.vala"
	_targets_size_ = targets_length1;
#line 153 "../src/Clipboard.vala"
	_tmp6_ = targets;
#line 153 "../src/Clipboard.vala"
	_tmp6__length1 = targets_length1;
#line 1046 "Clipboard.c"
	{
		GdkAtom* target_collection = NULL;
		gint target_collection_length1 = 0;
		gint _target_collection_size_ = 0;
		gint target_it = 0;
#line 153 "../src/Clipboard.vala"
		target_collection = _tmp6_;
#line 153 "../src/Clipboard.vala"
		target_collection_length1 = _tmp6__length1;
#line 153 "../src/Clipboard.vala"
		for (target_it = 0; target_it < target_collection_length1; target_it = target_it + 1) {
#line 1058 "Clipboard.c"
			GdkAtom target = (GdkAtom) 0U;
#line 153 "../src/Clipboard.vala"
			target = target_collection[target_it];
#line 1062 "Clipboard.c"
			{
				gchar* _tmp7_;
				gchar* _tmp8_;
				gboolean _tmp9_;
#line 154 "../src/Clipboard.vala"
				_tmp7_ = gdk_atom_name (target);
#line 154 "../src/Clipboard.vala"
				_tmp8_ = _tmp7_;
#line 154 "../src/Clipboard.vala"
				_tmp9_ = g_strcmp0 (_tmp8_, MINDER_CLIPBOARD_NODES_TARGET_NAME) == 0;
#line 154 "../src/Clipboard.vala"
				_g_free0 (_tmp8_);
#line 154 "../src/Clipboard.vala"
				if (_tmp9_) {
#line 155 "../src/Clipboard.vala"
					result = TRUE;
#line 155 "../src/Clipboard.vala"
					targets = (g_free (targets), NULL);
#line 155 "../src/Clipboard.vala"
					_g_object_unref0 (clipboard);
#line 155 "../src/Clipboard.vala"
					return result;
#line 1085 "Clipboard.c"
				}
			}
		}
	}
#line 159 "../src/Clipboard.vala"
	result = FALSE;
#line 159 "../src/Clipboard.vala"
	targets = (g_free (targets), NULL);
#line 159 "../src/Clipboard.vala"
	_g_object_unref0 (clipboard);
#line 159 "../src/Clipboard.vala"
	return result;
#line 1098 "Clipboard.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 164 "../src/Clipboard.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 164 "../src/Clipboard.vala"
	return _data3_;
#line 1108 "Clipboard.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 164 "../src/Clipboard.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 164 "../src/Clipboard.vala"
		_g_object_unref0 (_data3_->da);
#line 164 "../src/Clipboard.vala"
		g_slice_free (Block3Data, _data3_);
#line 1122 "Clipboard.c"
	}
}

static GdkAtom*
_gdk_atom_dup (GdkAtom* self)
{
	GdkAtom* dup;
#line 179 "../src/Clipboard.vala"
	dup = g_new0 (GdkAtom, 1);
#line 179 "../src/Clipboard.vala"
	memcpy (dup, self, sizeof (GdkAtom));
#line 179 "../src/Clipboard.vala"
	return dup;
#line 1136 "Clipboard.c"
}

static gpointer
__gdk_atom_dup0 (gpointer self)
{
#line 179 "../src/Clipboard.vala"
	return self ? _gdk_atom_dup (self) : NULL;
#line 1144 "Clipboard.c"
}

static void
___lambda49_ (Block3Data* _data3_,
              GtkClipboard* c,
              GtkSelectionData* raw_data)
{
	gchar* data = NULL;
	guint8* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 189 "../src/Clipboard.vala"
	g_return_if_fail (c != NULL);
#line 189 "../src/Clipboard.vala"
	g_return_if_fail (raw_data != NULL);
#line 190 "../src/Clipboard.vala"
	_tmp0_ = gtk_selection_data_get_data (raw_data);
#line 190 "../src/Clipboard.vala"
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
#line 190 "../src/Clipboard.vala"
	data = _tmp1_;
#line 191 "../src/Clipboard.vala"
	_tmp2_ = data;
#line 191 "../src/Clipboard.vala"
	if (_tmp2_ == NULL) {
#line 191 "../src/Clipboard.vala"
		_g_free0 (data);
#line 191 "../src/Clipboard.vala"
		return;
#line 1175 "Clipboard.c"
	}
#line 192 "../src/Clipboard.vala"
	_tmp3_ = data;
#line 192 "../src/Clipboard.vala"
	draw_area_paste_nodes (_data3_->da, _tmp3_, _data3_->shift);
#line 189 "../src/Clipboard.vala"
	_g_free0 (data);
#line 1183 "Clipboard.c"
}

static void
____lambda49__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                           GtkSelectionData* selection_data,
                                           gpointer self)
{
#line 189 "../src/Clipboard.vala"
	___lambda49_ (self, clipboard, selection_data);
#line 189 "../src/Clipboard.vala"
	block3_data_unref (self);
#line 1195 "Clipboard.c"
}

static void
____lambda50_ (Block3Data* _data3_,
               GtkClipboard* c,
               GtkSelectionData* raw_data)
{
	GdkPixbuf* data = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
#line 197 "../src/Clipboard.vala"
	g_return_if_fail (c != NULL);
#line 197 "../src/Clipboard.vala"
	g_return_if_fail (raw_data != NULL);
#line 198 "../src/Clipboard.vala"
	_tmp0_ = gtk_selection_data_get_pixbuf (raw_data);
#line 198 "../src/Clipboard.vala"
	data = _tmp0_;
#line 199 "../src/Clipboard.vala"
	_tmp1_ = data;
#line 199 "../src/Clipboard.vala"
	if (_tmp1_ == NULL) {
#line 199 "../src/Clipboard.vala"
		_g_object_unref0 (data);
#line 199 "../src/Clipboard.vala"
		return;
#line 1223 "Clipboard.c"
	}
#line 200 "../src/Clipboard.vala"
	_tmp2_ = data;
#line 200 "../src/Clipboard.vala"
	draw_area_paste_image (_data3_->da, _tmp2_, _data3_->shift);
#line 197 "../src/Clipboard.vala"
	_g_object_unref0 (data);
#line 1231 "Clipboard.c"
}

static void
_____lambda50__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                            GtkSelectionData* selection_data,
                                            gpointer self)
{
#line 197 "../src/Clipboard.vala"
	____lambda50_ (self, clipboard, selection_data);
#line 197 "../src/Clipboard.vala"
	block3_data_unref (self);
#line 1243 "Clipboard.c"
}

static void
_____lambda51_ (Block3Data* _data3_,
                GtkClipboard* c,
                GtkSelectionData* raw_data)
{
	gchar* data = NULL;
	guint8* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 205 "../src/Clipboard.vala"
	g_return_if_fail (c != NULL);
#line 205 "../src/Clipboard.vala"
	g_return_if_fail (raw_data != NULL);
#line 206 "../src/Clipboard.vala"
	_tmp0_ = gtk_selection_data_get_data (raw_data);
#line 206 "../src/Clipboard.vala"
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
#line 206 "../src/Clipboard.vala"
	data = _tmp1_;
#line 207 "../src/Clipboard.vala"
	_tmp2_ = data;
#line 207 "../src/Clipboard.vala"
	if (_tmp2_ == NULL) {
#line 207 "../src/Clipboard.vala"
		_g_free0 (data);
#line 207 "../src/Clipboard.vala"
		return;
#line 1274 "Clipboard.c"
	}
#line 208 "../src/Clipboard.vala"
	_tmp3_ = data;
#line 208 "../src/Clipboard.vala"
	draw_area_paste_text (_data3_->da, _tmp3_, _data3_->shift);
#line 205 "../src/Clipboard.vala"
	_g_free0 (data);
#line 1282 "Clipboard.c"
}

static void
______lambda51__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                             GtkSelectionData* selection_data,
                                             gpointer self)
{
#line 205 "../src/Clipboard.vala"
	_____lambda51_ (self, clipboard, selection_data);
#line 205 "../src/Clipboard.vala"
	block3_data_unref (self);
#line 1294 "Clipboard.c"
}

void
minder_clipboard_paste (DrawArea* da,
                        gboolean shift)
{
	Block3Data* _data3_;
	DrawArea* _tmp0_;
	GtkClipboard* clipboard = NULL;
	GdkDisplay* _tmp1_;
	GtkClipboard* _tmp2_;
	GtkClipboard* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean text_needed = FALSE;
	GdkAtom* targets = NULL;
	gint targets_length1 = 0;
	gint _targets_size_ = 0;
	GtkClipboard* _tmp5_;
	GdkAtom* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	GdkAtom* nodes_atom = NULL;
	GdkAtom* text_atom = NULL;
	GdkAtom* image_atom = NULL;
	GdkAtom* _tmp8_;
	gint _tmp8__length1;
	GdkAtom* _tmp28_;
#line 164 "../src/Clipboard.vala"
	g_return_if_fail (da != NULL);
#line 164 "../src/Clipboard.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 164 "../src/Clipboard.vala"
	_data3_->_ref_count_ = 1;
#line 164 "../src/Clipboard.vala"
	_tmp0_ = _g_object_ref0 (da);
#line 164 "../src/Clipboard.vala"
	_g_object_unref0 (_data3_->da);
#line 164 "../src/Clipboard.vala"
	_data3_->da = _tmp0_;
#line 164 "../src/Clipboard.vala"
	_data3_->shift = shift;
#line 166 "../src/Clipboard.vala"
	_tmp1_ = gdk_display_get_default ();
#line 166 "../src/Clipboard.vala"
	_tmp2_ = gtk_clipboard_get_default (_tmp1_);
#line 166 "../src/Clipboard.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 166 "../src/Clipboard.vala"
	clipboard = _tmp3_;
#line 167 "../src/Clipboard.vala"
	if (draw_area_is_node_editable (_data3_->da)) {
#line 167 "../src/Clipboard.vala"
		_tmp4_ = TRUE;
#line 1347 "Clipboard.c"
	} else {
#line 167 "../src/Clipboard.vala"
		_tmp4_ = draw_area_is_connection_editable (_data3_->da);
#line 1351 "Clipboard.c"
	}
#line 167 "../src/Clipboard.vala"
	text_needed = _tmp4_;
#line 170 "../src/Clipboard.vala"
	_tmp5_ = clipboard;
#line 170 "../src/Clipboard.vala"
	gtk_clipboard_wait_for_targets (_tmp5_, &_tmp6_, &_tmp7_);
#line 170 "../src/Clipboard.vala"
	targets = (g_free (targets), NULL);
#line 170 "../src/Clipboard.vala"
	targets = _tmp6_;
#line 170 "../src/Clipboard.vala"
	targets_length1 = _tmp7_;
#line 170 "../src/Clipboard.vala"
	_targets_size_ = targets_length1;
#line 172 "../src/Clipboard.vala"
	nodes_atom = NULL;
#line 173 "../src/Clipboard.vala"
	text_atom = NULL;
#line 174 "../src/Clipboard.vala"
	image_atom = NULL;
#line 177 "../src/Clipboard.vala"
	_tmp8_ = targets;
#line 177 "../src/Clipboard.vala"
	_tmp8__length1 = targets_length1;
#line 1377 "Clipboard.c"
	{
		GdkAtom* target_collection = NULL;
		gint target_collection_length1 = 0;
		gint _target_collection_size_ = 0;
		gint target_it = 0;
#line 177 "../src/Clipboard.vala"
		target_collection = _tmp8_;
#line 177 "../src/Clipboard.vala"
		target_collection_length1 = _tmp8__length1;
#line 177 "../src/Clipboard.vala"
		for (target_it = 0; target_it < target_collection_length1; target_it = target_it + 1) {
#line 1389 "Clipboard.c"
			GdkAtom target = (GdkAtom) 0U;
#line 177 "../src/Clipboard.vala"
			target = target_collection[target_it];
#line 1393 "Clipboard.c"
			{
				gchar* _tmp9_;
				gchar* _tmp10_;
				GQuark _tmp12_ = 0U;
#line 178 "../src/Clipboard.vala"
				static GQuark _tmp11_label0 = 0;
#line 178 "../src/Clipboard.vala"
				static GQuark _tmp11_label1 = 0;
#line 178 "../src/Clipboard.vala"
				static GQuark _tmp11_label2 = 0;
#line 178 "../src/Clipboard.vala"
				static GQuark _tmp11_label3 = 0;
#line 178 "../src/Clipboard.vala"
				static GQuark _tmp11_label4 = 0;
#line 178 "../src/Clipboard.vala"
				_tmp9_ = gdk_atom_name (target);
#line 178 "../src/Clipboard.vala"
				_tmp10_ = _tmp9_;
#line 178 "../src/Clipboard.vala"
				_tmp12_ = (NULL == _tmp10_) ? 0 : g_quark_from_string (_tmp10_);
#line 178 "../src/Clipboard.vala"
				g_free (_tmp10_);
#line 178 "../src/Clipboard.vala"
				if (_tmp12_ == ((0 != _tmp11_label0) ? _tmp11_label0 : (_tmp11_label0 = g_quark_from_static_string (MINDER_CLIPBOARD_NODES_TARGET_NAME)))) {
#line 178 "../src/Clipboard.vala"
					switch (0) {
#line 1420 "Clipboard.c"
						default:
						{
							GdkAtom* _tmp13_ = NULL;
							GdkAtom* _tmp14_;
							GdkAtom* _tmp15_;
							GdkAtom* _tmp17_;
#line 179 "../src/Clipboard.vala"
							_tmp14_ = nodes_atom;
#line 179 "../src/Clipboard.vala"
							_tmp15_ = __gdk_atom_dup0 (_tmp14_);
#line 179 "../src/Clipboard.vala"
							_tmp13_ = _tmp15_;
#line 179 "../src/Clipboard.vala"
							if (_tmp13_ == NULL) {
#line 1435 "Clipboard.c"
								GdkAtom* _tmp16_;
#line 179 "../src/Clipboard.vala"
								_tmp16_ = __gdk_atom_dup0 (&target);
#line 179 "../src/Clipboard.vala"
								_g_free0 (_tmp13_);
#line 179 "../src/Clipboard.vala"
								_tmp13_ = _tmp16_;
#line 1443 "Clipboard.c"
							}
#line 179 "../src/Clipboard.vala"
							_tmp17_ = _tmp13_;
#line 179 "../src/Clipboard.vala"
							_tmp13_ = NULL;
#line 179 "../src/Clipboard.vala"
							_g_free0 (nodes_atom);
#line 179 "../src/Clipboard.vala"
							nodes_atom = _tmp17_;
#line 179 "../src/Clipboard.vala"
							_g_free0 (_tmp13_);
#line 179 "../src/Clipboard.vala"
							break;
#line 1457 "Clipboard.c"
						}
					}
				} else if (((_tmp12_ == ((0 != _tmp11_label1) ? _tmp11_label1 : (_tmp11_label1 = g_quark_from_static_string ("UTF8_STRING")))) || (_tmp12_ == ((0 != _tmp11_label2) ? _tmp11_label2 : (_tmp11_label2 = g_quark_from_static_string ("STRING"))))) || (_tmp12_ == ((0 != _tmp11_label3) ? _tmp11_label3 : (_tmp11_label3 = g_quark_from_static_string ("text/plain"))))) {
#line 178 "../src/Clipboard.vala"
					switch (0) {
#line 1463 "Clipboard.c"
						default:
						{
							GdkAtom* _tmp18_ = NULL;
							GdkAtom* _tmp19_;
							GdkAtom* _tmp20_;
							GdkAtom* _tmp22_;
#line 182 "../src/Clipboard.vala"
							_tmp19_ = text_atom;
#line 182 "../src/Clipboard.vala"
							_tmp20_ = __gdk_atom_dup0 (_tmp19_);
#line 182 "../src/Clipboard.vala"
							_tmp18_ = _tmp20_;
#line 182 "../src/Clipboard.vala"
							if (_tmp18_ == NULL) {
#line 1478 "Clipboard.c"
								GdkAtom* _tmp21_;
#line 182 "../src/Clipboard.vala"
								_tmp21_ = __gdk_atom_dup0 (&target);
#line 182 "../src/Clipboard.vala"
								_g_free0 (_tmp18_);
#line 182 "../src/Clipboard.vala"
								_tmp18_ = _tmp21_;
#line 1486 "Clipboard.c"
							}
#line 182 "../src/Clipboard.vala"
							_tmp22_ = _tmp18_;
#line 182 "../src/Clipboard.vala"
							_tmp18_ = NULL;
#line 182 "../src/Clipboard.vala"
							_g_free0 (text_atom);
#line 182 "../src/Clipboard.vala"
							text_atom = _tmp22_;
#line 182 "../src/Clipboard.vala"
							_g_free0 (_tmp18_);
#line 182 "../src/Clipboard.vala"
							break;
#line 1500 "Clipboard.c"
						}
					}
				} else if (_tmp12_ == ((0 != _tmp11_label4) ? _tmp11_label4 : (_tmp11_label4 = g_quark_from_static_string ("image/png")))) {
#line 178 "../src/Clipboard.vala"
					switch (0) {
#line 1506 "Clipboard.c"
						default:
						{
							GdkAtom* _tmp23_ = NULL;
							GdkAtom* _tmp24_;
							GdkAtom* _tmp25_;
							GdkAtom* _tmp27_;
#line 183 "../src/Clipboard.vala"
							_tmp24_ = image_atom;
#line 183 "../src/Clipboard.vala"
							_tmp25_ = __gdk_atom_dup0 (_tmp24_);
#line 183 "../src/Clipboard.vala"
							_tmp23_ = _tmp25_;
#line 183 "../src/Clipboard.vala"
							if (_tmp23_ == NULL) {
#line 1521 "Clipboard.c"
								GdkAtom* _tmp26_;
#line 183 "../src/Clipboard.vala"
								_tmp26_ = __gdk_atom_dup0 (&target);
#line 183 "../src/Clipboard.vala"
								_g_free0 (_tmp23_);
#line 183 "../src/Clipboard.vala"
								_tmp23_ = _tmp26_;
#line 1529 "Clipboard.c"
							}
#line 183 "../src/Clipboard.vala"
							_tmp27_ = _tmp23_;
#line 183 "../src/Clipboard.vala"
							_tmp23_ = NULL;
#line 183 "../src/Clipboard.vala"
							_g_free0 (image_atom);
#line 183 "../src/Clipboard.vala"
							image_atom = _tmp27_;
#line 183 "../src/Clipboard.vala"
							_g_free0 (_tmp23_);
#line 183 "../src/Clipboard.vala"
							break;
#line 1543 "Clipboard.c"
						}
					}
				}
			}
		}
	}
#line 188 "../src/Clipboard.vala"
	_tmp28_ = nodes_atom;
#line 188 "../src/Clipboard.vala"
	if (_tmp28_ != NULL) {
#line 1554 "Clipboard.c"
		GtkClipboard* _tmp29_;
		GdkAtom* _tmp30_;
#line 189 "../src/Clipboard.vala"
		_tmp29_ = clipboard;
#line 189 "../src/Clipboard.vala"
		_tmp30_ = nodes_atom;
#line 189 "../src/Clipboard.vala"
		gtk_clipboard_request_contents (_tmp29_, *_tmp30_, ____lambda49__gtk_clipboard_received_func, block3_data_ref (_data3_));
#line 1563 "Clipboard.c"
	} else {
		gboolean _tmp31_ = FALSE;
		GdkAtom* _tmp32_;
#line 196 "../src/Clipboard.vala"
		_tmp32_ = image_atom;
#line 196 "../src/Clipboard.vala"
		if (_tmp32_ != NULL) {
#line 1571 "Clipboard.c"
			gboolean _tmp33_ = FALSE;
			GdkAtom* _tmp34_;
#line 196 "../src/Clipboard.vala"
			_tmp34_ = text_atom;
#line 196 "../src/Clipboard.vala"
			if (_tmp34_ == NULL) {
#line 196 "../src/Clipboard.vala"
				_tmp33_ = TRUE;
#line 1580 "Clipboard.c"
			} else {
#line 196 "../src/Clipboard.vala"
				_tmp33_ = !text_needed;
#line 1584 "Clipboard.c"
			}
#line 196 "../src/Clipboard.vala"
			_tmp31_ = _tmp33_;
#line 1588 "Clipboard.c"
		} else {
#line 196 "../src/Clipboard.vala"
			_tmp31_ = FALSE;
#line 1592 "Clipboard.c"
		}
#line 196 "../src/Clipboard.vala"
		if (_tmp31_) {
#line 1596 "Clipboard.c"
			GtkClipboard* _tmp35_;
			GdkAtom* _tmp36_;
#line 197 "../src/Clipboard.vala"
			_tmp35_ = clipboard;
#line 197 "../src/Clipboard.vala"
			_tmp36_ = image_atom;
#line 197 "../src/Clipboard.vala"
			gtk_clipboard_request_contents (_tmp35_, *_tmp36_, _____lambda50__gtk_clipboard_received_func, block3_data_ref (_data3_));
#line 1605 "Clipboard.c"
		} else {
			GdkAtom* _tmp37_;
#line 204 "../src/Clipboard.vala"
			_tmp37_ = text_atom;
#line 204 "../src/Clipboard.vala"
			if (_tmp37_ != NULL) {
#line 1612 "Clipboard.c"
				GtkClipboard* _tmp38_;
				GdkAtom* _tmp39_;
#line 205 "../src/Clipboard.vala"
				_tmp38_ = clipboard;
#line 205 "../src/Clipboard.vala"
				_tmp39_ = text_atom;
#line 205 "../src/Clipboard.vala"
				gtk_clipboard_request_contents (_tmp38_, *_tmp39_, ______lambda51__gtk_clipboard_received_func, block3_data_ref (_data3_));
#line 1621 "Clipboard.c"
			}
		}
	}
#line 164 "../src/Clipboard.vala"
	_g_free0 (image_atom);
#line 164 "../src/Clipboard.vala"
	_g_free0 (text_atom);
#line 164 "../src/Clipboard.vala"
	_g_free0 (nodes_atom);
#line 164 "../src/Clipboard.vala"
	targets = (g_free (targets), NULL);
#line 164 "../src/Clipboard.vala"
	_g_object_unref0 (clipboard);
#line 164 "../src/Clipboard.vala"
	block3_data_unref (_data3_);
#line 164 "../src/Clipboard.vala"
	_data3_ = NULL;
#line 1639 "Clipboard.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 215 "../src/Clipboard.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 215 "../src/Clipboard.vala"
	return _data4_;
#line 1649 "Clipboard.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 215 "../src/Clipboard.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 215 "../src/Clipboard.vala"
		_g_object_unref0 (_data4_->da);
#line 215 "../src/Clipboard.vala"
		g_slice_free (Block4Data, _data4_);
#line 1663 "Clipboard.c"
	}
}

static void
_____lambda52_ (Block4Data* _data4_,
                GtkClipboard* c,
                GtkSelectionData* raw_data)
{
	gchar* data = NULL;
	guint8* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 223 "../src/Clipboard.vala"
	g_return_if_fail (c != NULL);
#line 223 "../src/Clipboard.vala"
	g_return_if_fail (raw_data != NULL);
#line 224 "../src/Clipboard.vala"
	_tmp0_ = gtk_selection_data_get_data (raw_data);
#line 224 "../src/Clipboard.vala"
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
#line 224 "../src/Clipboard.vala"
	data = _tmp1_;
#line 225 "../src/Clipboard.vala"
	_tmp2_ = data;
#line 225 "../src/Clipboard.vala"
	if (_tmp2_ == NULL) {
#line 225 "../src/Clipboard.vala"
		_g_free0 (data);
#line 225 "../src/Clipboard.vala"
		return;
#line 1695 "Clipboard.c"
	}
#line 226 "../src/Clipboard.vala"
	_tmp3_ = data;
#line 226 "../src/Clipboard.vala"
	draw_area_paste_node_link (_data4_->da, _tmp3_);
#line 223 "../src/Clipboard.vala"
	_g_free0 (data);
#line 1703 "Clipboard.c"
}

static void
______lambda52__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                             GtkSelectionData* selection_data,
                                             gpointer self)
{
#line 223 "../src/Clipboard.vala"
	_____lambda52_ (self, clipboard, selection_data);
#line 223 "../src/Clipboard.vala"
	block4_data_unref (self);
#line 1715 "Clipboard.c"
}

void
minder_clipboard_paste_node_link (DrawArea* da)
{
	Block4Data* _data4_;
	DrawArea* _tmp0_;
	GtkClipboard* clipboard = NULL;
	GdkDisplay* _tmp1_;
	GtkClipboard* _tmp2_;
	GtkClipboard* _tmp3_;
	GdkAtom* targets = NULL;
	gint targets_length1 = 0;
	gint _targets_size_ = 0;
	GtkClipboard* _tmp4_;
	GdkAtom* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	GdkAtom* _tmp7_;
	gint _tmp7__length1;
#line 215 "../src/Clipboard.vala"
	g_return_if_fail (da != NULL);
#line 215 "../src/Clipboard.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 215 "../src/Clipboard.vala"
	_data4_->_ref_count_ = 1;
#line 215 "../src/Clipboard.vala"
	_tmp0_ = _g_object_ref0 (da);
#line 215 "../src/Clipboard.vala"
	_g_object_unref0 (_data4_->da);
#line 215 "../src/Clipboard.vala"
	_data4_->da = _tmp0_;
#line 216 "../src/Clipboard.vala"
	_tmp1_ = gdk_display_get_default ();
#line 216 "../src/Clipboard.vala"
	_tmp2_ = gtk_clipboard_get_default (_tmp1_);
#line 216 "../src/Clipboard.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 216 "../src/Clipboard.vala"
	clipboard = _tmp3_;
#line 219 "../src/Clipboard.vala"
	_tmp4_ = clipboard;
#line 219 "../src/Clipboard.vala"
	gtk_clipboard_wait_for_targets (_tmp4_, &_tmp5_, &_tmp6_);
#line 219 "../src/Clipboard.vala"
	targets = (g_free (targets), NULL);
#line 219 "../src/Clipboard.vala"
	targets = _tmp5_;
#line 219 "../src/Clipboard.vala"
	targets_length1 = _tmp6_;
#line 219 "../src/Clipboard.vala"
	_targets_size_ = targets_length1;
#line 221 "../src/Clipboard.vala"
	_tmp7_ = targets;
#line 221 "../src/Clipboard.vala"
	_tmp7__length1 = targets_length1;
#line 1771 "Clipboard.c"
	{
		GdkAtom* target_collection = NULL;
		gint target_collection_length1 = 0;
		gint _target_collection_size_ = 0;
		gint target_it = 0;
#line 221 "../src/Clipboard.vala"
		target_collection = _tmp7_;
#line 221 "../src/Clipboard.vala"
		target_collection_length1 = _tmp7__length1;
#line 221 "../src/Clipboard.vala"
		for (target_it = 0; target_it < target_collection_length1; target_it = target_it + 1) {
#line 1783 "Clipboard.c"
			GdkAtom target = (GdkAtom) 0U;
#line 221 "../src/Clipboard.vala"
			target = target_collection[target_it];
#line 1787 "Clipboard.c"
			{
				gchar* _tmp8_;
				gchar* _tmp9_;
				gboolean _tmp10_;
#line 222 "../src/Clipboard.vala"
				_tmp8_ = gdk_atom_name (target);
#line 222 "../src/Clipboard.vala"
				_tmp9_ = _tmp8_;
#line 222 "../src/Clipboard.vala"
				_tmp10_ = g_strcmp0 (_tmp9_, MINDER_CLIPBOARD_NODES_TARGET_NAME) == 0;
#line 222 "../src/Clipboard.vala"
				_g_free0 (_tmp9_);
#line 222 "../src/Clipboard.vala"
				if (_tmp10_) {
#line 1802 "Clipboard.c"
					GtkClipboard* _tmp11_;
#line 223 "../src/Clipboard.vala"
					_tmp11_ = clipboard;
#line 223 "../src/Clipboard.vala"
					gtk_clipboard_request_contents (_tmp11_, target, ______lambda52__gtk_clipboard_received_func, block4_data_ref (_data4_));
#line 228 "../src/Clipboard.vala"
					targets = (g_free (targets), NULL);
#line 228 "../src/Clipboard.vala"
					_g_object_unref0 (clipboard);
#line 228 "../src/Clipboard.vala"
					block4_data_unref (_data4_);
#line 228 "../src/Clipboard.vala"
					_data4_ = NULL;
#line 228 "../src/Clipboard.vala"
					return;
#line 1818 "Clipboard.c"
				}
			}
		}
	}
#line 215 "../src/Clipboard.vala"
	targets = (g_free (targets), NULL);
#line 215 "../src/Clipboard.vala"
	_g_object_unref0 (clipboard);
#line 215 "../src/Clipboard.vala"
	block4_data_unref (_data4_);
#line 215 "../src/Clipboard.vala"
	_data4_ = NULL;
#line 1831 "Clipboard.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 235 "../src/Clipboard.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 235 "../src/Clipboard.vala"
	return _data5_;
#line 1841 "Clipboard.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 235 "../src/Clipboard.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 235 "../src/Clipboard.vala"
		_g_object_unref0 (_data5_->note);
#line 235 "../src/Clipboard.vala"
		g_slice_free (Block5Data, _data5_);
#line 1855 "Clipboard.c"
	}
}

static void
___lambda53_ (Block5Data* _data5_,
              GtkClipboard* c,
              GtkSelectionData* raw_data)
{
	gchar* data = NULL;
	guint8* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	NodeLink* link = NULL;
	const gchar* _tmp3_;
	NodeLink* _tmp4_;
	NodeLink* _tmp5_;
#line 256 "../src/Clipboard.vala"
	g_return_if_fail (c != NULL);
#line 256 "../src/Clipboard.vala"
	g_return_if_fail (raw_data != NULL);
#line 257 "../src/Clipboard.vala"
	_tmp0_ = gtk_selection_data_get_data (raw_data);
#line 257 "../src/Clipboard.vala"
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
#line 257 "../src/Clipboard.vala"
	data = _tmp1_;
#line 258 "../src/Clipboard.vala"
	_tmp2_ = data;
#line 258 "../src/Clipboard.vala"
	if (_tmp2_ == NULL) {
#line 258 "../src/Clipboard.vala"
		_g_free0 (data);
#line 258 "../src/Clipboard.vala"
		return;
#line 1890 "Clipboard.c"
	}
#line 259 "../src/Clipboard.vala"
	_tmp3_ = data;
#line 259 "../src/Clipboard.vala"
	_tmp4_ = draw_area_deserialize_for_node_link (_tmp3_);
#line 259 "../src/Clipboard.vala"
	link = _tmp4_;
#line 260 "../src/Clipboard.vala"
	_tmp5_ = link;
#line 260 "../src/Clipboard.vala"
	if (_tmp5_ != NULL) {
#line 1902 "Clipboard.c"
		NodeLink* _tmp6_;
#line 261 "../src/Clipboard.vala"
		_tmp6_ = link;
#line 261 "../src/Clipboard.vala"
		note_view_paste_node_link (_data5_->note, _tmp6_);
#line 1908 "Clipboard.c"
	}
#line 256 "../src/Clipboard.vala"
	_node_link_unref0 (link);
#line 256 "../src/Clipboard.vala"
	_g_free0 (data);
#line 1914 "Clipboard.c"
}

static void
____lambda53__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                           GtkSelectionData* selection_data,
                                           gpointer self)
{
#line 256 "../src/Clipboard.vala"
	___lambda53_ (self, clipboard, selection_data);
#line 256 "../src/Clipboard.vala"
	block5_data_unref (self);
#line 1926 "Clipboard.c"
}

static void
____lambda54_ (Block5Data* _data5_,
               GtkClipboard* c,
               GtkSelectionData* raw_data)
{
	gchar* data = NULL;
	guint8* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 266 "../src/Clipboard.vala"
	g_return_if_fail (c != NULL);
#line 266 "../src/Clipboard.vala"
	g_return_if_fail (raw_data != NULL);
#line 267 "../src/Clipboard.vala"
	_tmp0_ = gtk_selection_data_get_data (raw_data);
#line 267 "../src/Clipboard.vala"
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
#line 267 "../src/Clipboard.vala"
	data = _tmp1_;
#line 268 "../src/Clipboard.vala"
	_tmp2_ = data;
#line 268 "../src/Clipboard.vala"
	if (_tmp2_ == NULL) {
#line 268 "../src/Clipboard.vala"
		_g_free0 (data);
#line 268 "../src/Clipboard.vala"
		return;
#line 1957 "Clipboard.c"
	}
#line 269 "../src/Clipboard.vala"
	_tmp3_ = data;
#line 269 "../src/Clipboard.vala"
	note_view_paste_text (_data5_->note, _tmp3_);
#line 266 "../src/Clipboard.vala"
	_g_free0 (data);
#line 1965 "Clipboard.c"
}

static void
_____lambda54__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                            GtkSelectionData* selection_data,
                                            gpointer self)
{
#line 266 "../src/Clipboard.vala"
	____lambda54_ (self, clipboard, selection_data);
#line 266 "../src/Clipboard.vala"
	block5_data_unref (self);
#line 1977 "Clipboard.c"
}

void
minder_clipboard_paste_into_note (NoteView* note)
{
	Block5Data* _data5_;
	NoteView* _tmp0_;
	GtkClipboard* clipboard = NULL;
	GdkDisplay* _tmp1_;
	GtkClipboard* _tmp2_;
	GtkClipboard* _tmp3_;
	GdkAtom* targets = NULL;
	gint targets_length1 = 0;
	gint _targets_size_ = 0;
	GtkClipboard* _tmp4_;
	GdkAtom* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	GdkAtom* nodes_atom = NULL;
	GdkAtom* text_atom = NULL;
	GdkAtom* _tmp7_;
	gint _tmp7__length1;
	GdkAtom* _tmp22_;
#line 235 "../src/Clipboard.vala"
	g_return_if_fail (note != NULL);
#line 235 "../src/Clipboard.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 235 "../src/Clipboard.vala"
	_data5_->_ref_count_ = 1;
#line 235 "../src/Clipboard.vala"
	_tmp0_ = _g_object_ref0 (note);
#line 235 "../src/Clipboard.vala"
	_g_object_unref0 (_data5_->note);
#line 235 "../src/Clipboard.vala"
	_data5_->note = _tmp0_;
#line 237 "../src/Clipboard.vala"
	_tmp1_ = gdk_display_get_default ();
#line 237 "../src/Clipboard.vala"
	_tmp2_ = gtk_clipboard_get_default (_tmp1_);
#line 237 "../src/Clipboard.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 237 "../src/Clipboard.vala"
	clipboard = _tmp3_;
#line 240 "../src/Clipboard.vala"
	_tmp4_ = clipboard;
#line 240 "../src/Clipboard.vala"
	gtk_clipboard_wait_for_targets (_tmp4_, &_tmp5_, &_tmp6_);
#line 240 "../src/Clipboard.vala"
	targets = (g_free (targets), NULL);
#line 240 "../src/Clipboard.vala"
	targets = _tmp5_;
#line 240 "../src/Clipboard.vala"
	targets_length1 = _tmp6_;
#line 240 "../src/Clipboard.vala"
	_targets_size_ = targets_length1;
#line 242 "../src/Clipboard.vala"
	nodes_atom = NULL;
#line 243 "../src/Clipboard.vala"
	text_atom = NULL;
#line 246 "../src/Clipboard.vala"
	_tmp7_ = targets;
#line 246 "../src/Clipboard.vala"
	_tmp7__length1 = targets_length1;
#line 2040 "Clipboard.c"
	{
		GdkAtom* target_collection = NULL;
		gint target_collection_length1 = 0;
		gint _target_collection_size_ = 0;
		gint target_it = 0;
#line 246 "../src/Clipboard.vala"
		target_collection = _tmp7_;
#line 246 "../src/Clipboard.vala"
		target_collection_length1 = _tmp7__length1;
#line 246 "../src/Clipboard.vala"
		for (target_it = 0; target_it < target_collection_length1; target_it = target_it + 1) {
#line 2052 "Clipboard.c"
			GdkAtom target = (GdkAtom) 0U;
#line 246 "../src/Clipboard.vala"
			target = target_collection[target_it];
#line 2056 "Clipboard.c"
			{
				gchar* _tmp8_;
				gchar* _tmp9_;
				GQuark _tmp11_ = 0U;
#line 247 "../src/Clipboard.vala"
				static GQuark _tmp10_label0 = 0;
#line 247 "../src/Clipboard.vala"
				static GQuark _tmp10_label1 = 0;
#line 247 "../src/Clipboard.vala"
				static GQuark _tmp10_label2 = 0;
#line 247 "../src/Clipboard.vala"
				static GQuark _tmp10_label3 = 0;
#line 247 "../src/Clipboard.vala"
				_tmp8_ = gdk_atom_name (target);
#line 247 "../src/Clipboard.vala"
				_tmp9_ = _tmp8_;
#line 247 "../src/Clipboard.vala"
				_tmp11_ = (NULL == _tmp9_) ? 0 : g_quark_from_string (_tmp9_);
#line 247 "../src/Clipboard.vala"
				g_free (_tmp9_);
#line 247 "../src/Clipboard.vala"
				if (_tmp11_ == ((0 != _tmp10_label0) ? _tmp10_label0 : (_tmp10_label0 = g_quark_from_static_string (MINDER_CLIPBOARD_NODES_TARGET_NAME)))) {
#line 247 "../src/Clipboard.vala"
					switch (0) {
#line 2081 "Clipboard.c"
						default:
						{
							GdkAtom* _tmp12_ = NULL;
							GdkAtom* _tmp13_;
							GdkAtom* _tmp14_;
							GdkAtom* _tmp16_;
#line 248 "../src/Clipboard.vala"
							_tmp13_ = nodes_atom;
#line 248 "../src/Clipboard.vala"
							_tmp14_ = __gdk_atom_dup0 (_tmp13_);
#line 248 "../src/Clipboard.vala"
							_tmp12_ = _tmp14_;
#line 248 "../src/Clipboard.vala"
							if (_tmp12_ == NULL) {
#line 2096 "Clipboard.c"
								GdkAtom* _tmp15_;
#line 248 "../src/Clipboard.vala"
								_tmp15_ = __gdk_atom_dup0 (&target);
#line 248 "../src/Clipboard.vala"
								_g_free0 (_tmp12_);
#line 248 "../src/Clipboard.vala"
								_tmp12_ = _tmp15_;
#line 2104 "Clipboard.c"
							}
#line 248 "../src/Clipboard.vala"
							_tmp16_ = _tmp12_;
#line 248 "../src/Clipboard.vala"
							_tmp12_ = NULL;
#line 248 "../src/Clipboard.vala"
							_g_free0 (nodes_atom);
#line 248 "../src/Clipboard.vala"
							nodes_atom = _tmp16_;
#line 248 "../src/Clipboard.vala"
							_g_free0 (_tmp12_);
#line 248 "../src/Clipboard.vala"
							break;
#line 2118 "Clipboard.c"
						}
					}
				} else if (((_tmp11_ == ((0 != _tmp10_label1) ? _tmp10_label1 : (_tmp10_label1 = g_quark_from_static_string ("UTF8_STRING")))) || (_tmp11_ == ((0 != _tmp10_label2) ? _tmp10_label2 : (_tmp10_label2 = g_quark_from_static_string ("STRING"))))) || (_tmp11_ == ((0 != _tmp10_label3) ? _tmp10_label3 : (_tmp10_label3 = g_quark_from_static_string ("text/plain"))))) {
#line 247 "../src/Clipboard.vala"
					switch (0) {
#line 2124 "Clipboard.c"
						default:
						{
							GdkAtom* _tmp17_ = NULL;
							GdkAtom* _tmp18_;
							GdkAtom* _tmp19_;
							GdkAtom* _tmp21_;
#line 251 "../src/Clipboard.vala"
							_tmp18_ = text_atom;
#line 251 "../src/Clipboard.vala"
							_tmp19_ = __gdk_atom_dup0 (_tmp18_);
#line 251 "../src/Clipboard.vala"
							_tmp17_ = _tmp19_;
#line 251 "../src/Clipboard.vala"
							if (_tmp17_ == NULL) {
#line 2139 "Clipboard.c"
								GdkAtom* _tmp20_;
#line 251 "../src/Clipboard.vala"
								_tmp20_ = __gdk_atom_dup0 (&target);
#line 251 "../src/Clipboard.vala"
								_g_free0 (_tmp17_);
#line 251 "../src/Clipboard.vala"
								_tmp17_ = _tmp20_;
#line 2147 "Clipboard.c"
							}
#line 251 "../src/Clipboard.vala"
							_tmp21_ = _tmp17_;
#line 251 "../src/Clipboard.vala"
							_tmp17_ = NULL;
#line 251 "../src/Clipboard.vala"
							_g_free0 (text_atom);
#line 251 "../src/Clipboard.vala"
							text_atom = _tmp21_;
#line 251 "../src/Clipboard.vala"
							_g_free0 (_tmp17_);
#line 251 "../src/Clipboard.vala"
							break;
#line 2161 "Clipboard.c"
						}
					}
				}
			}
		}
	}
#line 255 "../src/Clipboard.vala"
	_tmp22_ = nodes_atom;
#line 255 "../src/Clipboard.vala"
	if (_tmp22_ != NULL) {
#line 2172 "Clipboard.c"
		GtkClipboard* _tmp23_;
		GdkAtom* _tmp24_;
#line 256 "../src/Clipboard.vala"
		_tmp23_ = clipboard;
#line 256 "../src/Clipboard.vala"
		_tmp24_ = nodes_atom;
#line 256 "../src/Clipboard.vala"
		gtk_clipboard_request_contents (_tmp23_, *_tmp24_, ____lambda53__gtk_clipboard_received_func, block5_data_ref (_data5_));
#line 2181 "Clipboard.c"
	} else {
		GdkAtom* _tmp25_;
#line 265 "../src/Clipboard.vala"
		_tmp25_ = text_atom;
#line 265 "../src/Clipboard.vala"
		if (_tmp25_ != NULL) {
#line 2188 "Clipboard.c"
			GtkClipboard* _tmp26_;
			GdkAtom* _tmp27_;
#line 266 "../src/Clipboard.vala"
			_tmp26_ = clipboard;
#line 266 "../src/Clipboard.vala"
			_tmp27_ = text_atom;
#line 266 "../src/Clipboard.vala"
			gtk_clipboard_request_contents (_tmp26_, *_tmp27_, _____lambda54__gtk_clipboard_received_func, block5_data_ref (_data5_));
#line 2197 "Clipboard.c"
		}
	}
#line 235 "../src/Clipboard.vala"
	_g_free0 (text_atom);
#line 235 "../src/Clipboard.vala"
	_g_free0 (nodes_atom);
#line 235 "../src/Clipboard.vala"
	targets = (g_free (targets), NULL);
#line 235 "../src/Clipboard.vala"
	_g_object_unref0 (clipboard);
#line 235 "../src/Clipboard.vala"
	block5_data_unref (_data5_);
#line 235 "../src/Clipboard.vala"
	_data5_ = NULL;
#line 2212 "Clipboard.c"
}

MinderClipboard*
minder_clipboard_construct (GType object_type)
{
	MinderClipboard* self = NULL;
#line 27 "../src/Clipboard.vala"
	self = (MinderClipboard*) g_type_create_instance (object_type);
#line 27 "../src/Clipboard.vala"
	return self;
#line 2223 "Clipboard.c"
}

MinderClipboard*
minder_clipboard_new (void)
{
#line 27 "../src/Clipboard.vala"
	return minder_clipboard_construct (TYPE_MINDER_CLIPBOARD);
#line 2231 "Clipboard.c"
}

static void
value_minder_clipboard_init (GValue* value)
{
#line 27 "../src/Clipboard.vala"
	value->data[0].v_pointer = NULL;
#line 2239 "Clipboard.c"
}

static void
value_minder_clipboard_free_value (GValue* value)
{
#line 27 "../src/Clipboard.vala"
	if (value->data[0].v_pointer) {
#line 27 "../src/Clipboard.vala"
		minder_clipboard_unref (value->data[0].v_pointer);
#line 2249 "Clipboard.c"
	}
}

static void
value_minder_clipboard_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
#line 27 "../src/Clipboard.vala"
	if (src_value->data[0].v_pointer) {
#line 27 "../src/Clipboard.vala"
		dest_value->data[0].v_pointer = minder_clipboard_ref (src_value->data[0].v_pointer);
#line 2261 "Clipboard.c"
	} else {
#line 27 "../src/Clipboard.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2265 "Clipboard.c"
	}
}

static gpointer
value_minder_clipboard_peek_pointer (const GValue* value)
{
#line 27 "../src/Clipboard.vala"
	return value->data[0].v_pointer;
#line 2274 "Clipboard.c"
}

static gchar*
value_minder_clipboard_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
#line 27 "../src/Clipboard.vala"
	if (collect_values[0].v_pointer) {
#line 2285 "Clipboard.c"
		MinderClipboard * object;
		object = collect_values[0].v_pointer;
#line 27 "../src/Clipboard.vala"
		if (object->parent_instance.g_class == NULL) {
#line 27 "../src/Clipboard.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2292 "Clipboard.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 27 "../src/Clipboard.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2296 "Clipboard.c"
		}
#line 27 "../src/Clipboard.vala"
		value->data[0].v_pointer = minder_clipboard_ref (object);
#line 2300 "Clipboard.c"
	} else {
#line 27 "../src/Clipboard.vala"
		value->data[0].v_pointer = NULL;
#line 2304 "Clipboard.c"
	}
#line 27 "../src/Clipboard.vala"
	return NULL;
#line 2308 "Clipboard.c"
}

static gchar*
value_minder_clipboard_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	MinderClipboard ** object_p;
	object_p = collect_values[0].v_pointer;
#line 27 "../src/Clipboard.vala"
	if (!object_p) {
#line 27 "../src/Clipboard.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2323 "Clipboard.c"
	}
#line 27 "../src/Clipboard.vala"
	if (!value->data[0].v_pointer) {
#line 27 "../src/Clipboard.vala"
		*object_p = NULL;
#line 2329 "Clipboard.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 27 "../src/Clipboard.vala"
		*object_p = value->data[0].v_pointer;
#line 2333 "Clipboard.c"
	} else {
#line 27 "../src/Clipboard.vala"
		*object_p = minder_clipboard_ref (value->data[0].v_pointer);
#line 2337 "Clipboard.c"
	}
#line 27 "../src/Clipboard.vala"
	return NULL;
#line 2341 "Clipboard.c"
}

GParamSpec*
param_spec_minder_clipboard (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	ParamSpecMinderClipboard* spec;
#line 27 "../src/Clipboard.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_MINDER_CLIPBOARD), NULL);
#line 27 "../src/Clipboard.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 27 "../src/Clipboard.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 27 "../src/Clipboard.vala"
	return G_PARAM_SPEC (spec);
#line 2360 "Clipboard.c"
}

gpointer
value_get_minder_clipboard (const GValue* value)
{
#line 27 "../src/Clipboard.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MINDER_CLIPBOARD), NULL);
#line 27 "../src/Clipboard.vala"
	return value->data[0].v_pointer;
#line 2370 "Clipboard.c"
}

void
value_set_minder_clipboard (GValue* value,
                            gpointer v_object)
{
	MinderClipboard * old;
#line 27 "../src/Clipboard.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MINDER_CLIPBOARD));
#line 27 "../src/Clipboard.vala"
	old = value->data[0].v_pointer;
#line 27 "../src/Clipboard.vala"
	if (v_object) {
#line 27 "../src/Clipboard.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MINDER_CLIPBOARD));
#line 27 "../src/Clipboard.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../src/Clipboard.vala"
		value->data[0].v_pointer = v_object;
#line 27 "../src/Clipboard.vala"
		minder_clipboard_ref (value->data[0].v_pointer);
#line 2392 "Clipboard.c"
	} else {
#line 27 "../src/Clipboard.vala"
		value->data[0].v_pointer = NULL;
#line 2396 "Clipboard.c"
	}
#line 27 "../src/Clipboard.vala"
	if (old) {
#line 27 "../src/Clipboard.vala"
		minder_clipboard_unref (old);
#line 2402 "Clipboard.c"
	}
}

void
value_take_minder_clipboard (GValue* value,
                             gpointer v_object)
{
	MinderClipboard * old;
#line 27 "../src/Clipboard.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MINDER_CLIPBOARD));
#line 27 "../src/Clipboard.vala"
	old = value->data[0].v_pointer;
#line 27 "../src/Clipboard.vala"
	if (v_object) {
#line 27 "../src/Clipboard.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MINDER_CLIPBOARD));
#line 27 "../src/Clipboard.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../src/Clipboard.vala"
		value->data[0].v_pointer = v_object;
#line 2423 "Clipboard.c"
	} else {
#line 27 "../src/Clipboard.vala"
		value->data[0].v_pointer = NULL;
#line 2427 "Clipboard.c"
	}
#line 27 "../src/Clipboard.vala"
	if (old) {
#line 27 "../src/Clipboard.vala"
		minder_clipboard_unref (old);
#line 2433 "Clipboard.c"
	}
}

static void
minder_clipboard_class_init (MinderClipboardClass * klass,
                             gpointer klass_data)
{
#line 27 "../src/Clipboard.vala"
	minder_clipboard_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/Clipboard.vala"
	((MinderClipboardClass *) klass)->finalize = minder_clipboard_finalize;
#line 30 "../src/Clipboard.vala"
	minder_clipboard_NODES_ATOM = gdk_atom_intern_static_string (MINDER_CLIPBOARD_NODES_TARGET_NAME);
#line 2447 "Clipboard.c"
}

static void
minder_clipboard_instance_init (MinderClipboard * self,
                                gpointer klass)
{
#line 27 "../src/Clipboard.vala"
	self->ref_count = 1;
#line 2456 "Clipboard.c"
}

static void
minder_clipboard_finalize (MinderClipboard * obj)
{
	MinderClipboard * self;
#line 27 "../src/Clipboard.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MINDER_CLIPBOARD, MinderClipboard);
#line 27 "../src/Clipboard.vala"
	g_signal_handlers_destroy (self);
#line 2467 "Clipboard.c"
}

static GType
minder_clipboard_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_minder_clipboard_init, value_minder_clipboard_free_value, value_minder_clipboard_copy_value, value_minder_clipboard_peek_pointer, "p", value_minder_clipboard_collect_value, "p", value_minder_clipboard_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MinderClipboardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) minder_clipboard_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MinderClipboard), 0, (GInstanceInitFunc) minder_clipboard_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType minder_clipboard_type_id;
	minder_clipboard_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MinderClipboard", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return minder_clipboard_type_id;
}

GType
minder_clipboard_get_type (void)
{
	static volatile gsize minder_clipboard_type_id__once = 0;
	if (g_once_init_enter (&minder_clipboard_type_id__once)) {
		GType minder_clipboard_type_id;
		minder_clipboard_type_id = minder_clipboard_get_type_once ();
		g_once_init_leave (&minder_clipboard_type_id__once, minder_clipboard_type_id);
	}
	return minder_clipboard_type_id__once;
}

gpointer
minder_clipboard_ref (gpointer instance)
{
	MinderClipboard * self;
	self = instance;
#line 27 "../src/Clipboard.vala"
	g_atomic_int_inc (&self->ref_count);
#line 27 "../src/Clipboard.vala"
	return instance;
#line 2502 "Clipboard.c"
}

void
minder_clipboard_unref (gpointer instance)
{
	MinderClipboard * self;
	self = instance;
#line 27 "../src/Clipboard.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 27 "../src/Clipboard.vala"
		MINDER_CLIPBOARD_GET_CLASS (self)->finalize (self);
#line 27 "../src/Clipboard.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2516 "Clipboard.c"
	}
}

