/* LayoutDown.c generated by valac 0.56.17, the Vala compiler
 * generated from LayoutDown.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_LAYOUT (layout_get_type ())
#define LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT, Layout))
#define LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT, LayoutClass))
#define IS_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT))
#define IS_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT))
#define LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT, LayoutClass))

typedef struct _Layout Layout;
typedef struct _LayoutClass LayoutClass;
typedef struct _LayoutPrivate LayoutPrivate;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;

#define TYPE_NODE_SIDE (node_side_get_type ())

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_NODE_BOUNDS (node_bounds_get_type ())
#define NODE_BOUNDS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_BOUNDS, NodeBounds))
#define NODE_BOUNDS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE_BOUNDS, NodeBoundsClass))
#define IS_NODE_BOUNDS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_BOUNDS))
#define IS_NODE_BOUNDS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE_BOUNDS))
#define NODE_BOUNDS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE_BOUNDS, NodeBoundsClass))

typedef struct _NodeBounds NodeBounds;
typedef struct _NodeBoundsClass NodeBoundsClass;

#define TYPE_LAYOUT_DOWN (layout_down_get_type ())
#define LAYOUT_DOWN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT_DOWN, LayoutDown))
#define LAYOUT_DOWN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT_DOWN, LayoutDownClass))
#define IS_LAYOUT_DOWN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT_DOWN))
#define IS_LAYOUT_DOWN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT_DOWN))
#define LAYOUT_DOWN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT_DOWN, LayoutDownClass))

typedef struct _LayoutDown LayoutDown;
typedef struct _LayoutDownClass LayoutDownClass;
typedef struct _LayoutDownPrivate LayoutDownPrivate;
enum  {
	LAYOUT_DOWN_0_PROPERTY,
	LAYOUT_DOWN_NUM_PROPERTIES
};
static GParamSpec* layout_down_properties[LAYOUT_DOWN_NUM_PROPERTIES];

struct _Layout {
	GObject parent_instance;
	LayoutPrivate * priv;
	gdouble _rt_gap;
};

struct _LayoutClass {
	GObjectClass parent_class;
	NodeSide (*side_mapping) (Layout* self, NodeSide side);
	void (*initialize) (Layout* self, Node* parent);
	NodeBounds* (*bbox) (Layout* self, Node* parent, gint side_mask, const gchar* msg);
	void (*adjust_tree) (Layout* self, Node* parent, gint child_index, gint side_mask, gdouble amount);
	void (*adjust_tree_all) (Layout* self, Node* n, NodeBounds* p, gdouble amount, const gchar* msg);
	void (*propagate_side) (Layout* self, Node* parent, NodeSide side);
	NodeSide (*get_side) (Layout* self, Node* n);
	void (*set_side) (Layout* self, Node* current);
	void (*handle_update_by_edit) (Layout* self, Node* n, gdouble diffw, gdouble diffh);
	void (*handle_update_by_fold) (Layout* self, Node* n);
	gdouble (*get_insert_adjust) (Layout* self, Node* child);
	void (*handle_update_by_insert) (Layout* self, Node* parent, Node* child, gint pos);
	void (*handle_update_by_delete) (Layout* self, Node* parent, gint index, NodeSide side, gdouble size);
	void (*position_root) (Layout* self, Node* last, Node* n);
};

struct _LayoutDown {
	Layout parent_instance;
	LayoutDownPrivate * priv;
};

struct _LayoutDownClass {
	LayoutClass parent_class;
};

static gpointer layout_down_parent_class = NULL;

VALA_EXTERN GType layout_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Layout, g_object_unref)
VALA_EXTERN GType node_side_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType node_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
VALA_EXTERN gpointer node_bounds_ref (gpointer instance);
VALA_EXTERN void node_bounds_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_node_bounds (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_node_bounds (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_node_bounds (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_node_bounds (const GValue* value);
VALA_EXTERN GType node_bounds_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NodeBounds, node_bounds_unref)
VALA_EXTERN GType layout_down_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LayoutDown, g_object_unref)
VALA_EXTERN NodeSide layout_side_mapping (Layout* self,
                              NodeSide side);
VALA_EXTERN void layout_set_side (Layout* self,
                      Node* current);
VALA_EXTERN LayoutDown* layout_down_new (void);
VALA_EXTERN LayoutDown* layout_down_construct (GType object_type);
VALA_EXTERN Layout* layout_new (void);
VALA_EXTERN Layout* layout_construct (GType object_type);
VALA_EXTERN void layout_set_name (Layout* self,
                      const gchar* value);
VALA_EXTERN void layout_set_icon (Layout* self,
                      const gchar* value);
VALA_EXTERN void layout_set_balanceable (Layout* self,
                             gboolean value);
static NodeSide layout_down_real_side_mapping (Layout* base,
                                        NodeSide side);
static void layout_down_real_set_side (Layout* base,
                                Node* current);
VALA_EXTERN void node_set_side (Node* self,
                    NodeSide value);
static GType layout_down_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

LayoutDown*
layout_down_construct (GType object_type)
{
	LayoutDown * self = NULL;
#line 25 "../src/layouts/LayoutDown.vala"
	self = (LayoutDown*) layout_construct (object_type);
#line 26 "../src/layouts/LayoutDown.vala"
	layout_set_name ((Layout*) self, _ ("Downwards"));
#line 27 "../src/layouts/LayoutDown.vala"
	layout_set_icon ((Layout*) self, "minder-layout-down-symbolic");
#line 28 "../src/layouts/LayoutDown.vala"
	layout_set_balanceable ((Layout*) self, FALSE);
#line 25 "../src/layouts/LayoutDown.vala"
	return self;
#line 201 "LayoutDown.c"
}

LayoutDown*
layout_down_new (void)
{
#line 25 "../src/layouts/LayoutDown.vala"
	return layout_down_construct (TYPE_LAYOUT_DOWN);
#line 209 "LayoutDown.c"
}

static NodeSide
layout_down_real_side_mapping (Layout* base,
                               NodeSide side)
{
	LayoutDown * self;
	NodeSide result;
#line 32 "../src/layouts/LayoutDown.vala"
	self = (LayoutDown*) base;
#line 33 "../src/layouts/LayoutDown.vala"
	result = NODE_SIDE_BOTTOM;
#line 33 "../src/layouts/LayoutDown.vala"
	return result;
#line 224 "LayoutDown.c"
}

static void
layout_down_real_set_side (Layout* base,
                           Node* current)
{
	LayoutDown * self;
#line 37 "../src/layouts/LayoutDown.vala"
	self = (LayoutDown*) base;
#line 37 "../src/layouts/LayoutDown.vala"
	g_return_if_fail (current != NULL);
#line 38 "../src/layouts/LayoutDown.vala"
	node_set_side (current, NODE_SIDE_BOTTOM);
#line 238 "LayoutDown.c"
}

static void
layout_down_class_init (LayoutDownClass * klass,
                        gpointer klass_data)
{
#line 22 "../src/layouts/LayoutDown.vala"
	layout_down_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/layouts/LayoutDown.vala"
	((LayoutClass *) klass)->side_mapping = (NodeSide (*) (Layout*, NodeSide)) layout_down_real_side_mapping;
#line 22 "../src/layouts/LayoutDown.vala"
	((LayoutClass *) klass)->set_side = (void (*) (Layout*, Node*)) layout_down_real_set_side;
#line 251 "LayoutDown.c"
}

static void
layout_down_instance_init (LayoutDown * self,
                           gpointer klass)
{
}

static GType
layout_down_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LayoutDownClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) layout_down_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LayoutDown), 0, (GInstanceInitFunc) layout_down_instance_init, NULL };
	GType layout_down_type_id;
	layout_down_type_id = g_type_register_static (TYPE_LAYOUT, "LayoutDown", &g_define_type_info, 0);
	return layout_down_type_id;
}

GType
layout_down_get_type (void)
{
	static volatile gsize layout_down_type_id__once = 0;
	if (g_once_init_enter (&layout_down_type_id__once)) {
		GType layout_down_type_id;
		layout_down_type_id = layout_down_get_type_once ();
		g_once_init_leave (&layout_down_type_id__once, layout_down_type_id);
	}
	return layout_down_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

